#pragma once
#include <us/gov/types.h>
#include <us/gov/config.h>
#include <us/gov/engine/evidence.h>

#include "locking_program_input_t.h"

namespace us::gov::cash {

    struct file_tx final: engine::evidence {
        using b = engine::evidence;

        static constexpr eid_t eid{2};

    public:
        file_tx();
        ~file_tx() override {}

    public:
        string name() const override { return "cash::file_tx"; }
        sigmsg_hash_t get_hash() const;
        void write_sigmsg(sigmsg_hasher_t&) const;
        void write_pretty_en(ostream&) const override;
        void write_pretty_es(ostream&) const override;
        uint64_t uniq() const override { return *reinterpret_cast<const uint64_t*>(&locking_program_input.sig); }

    public:
        size_t blob_size() const override;
        void to_blob(blob_writer_t&) const override;
        ko from_blob(blob_reader_t&) override;

    public:
        hash_t address;
        locking_program_input_t locking_program_input;
        hash_t digest;
        uint64_t size;
        string path;
    };

    static ostream& operator << (ostream& os, const cash::file_tx& t) {
        os << t.encode();
        return os;
    }

}

