#pragma once
#include <us/gov/types.h>
#include <us/gov/config.h>
#include <us/gov/engine/evidence.h>

#include "locking_program_input_t.h"

namespace us::gov::cash {

    struct map_tx final: engine::evidence {
        using b = engine::evidence;

        static constexpr eid_t eid{1};

        map_tx();
        ~map_tx() override {}

        string name() const override { return "cash::map_tx"; }
        sigmsg_hash_t get_hash() const;
        void write_sigmsg(sigmsg_hasher_t&) const;
        void write_pretty_en(ostream& os) const override;
        void write_pretty_es(ostream& os) const override;
        uint64_t uniq() const override { return *reinterpret_cast<const uint64_t*>(&locking_program_input.sig); }

    public:
        size_t blob_size() const override;
        void to_blob(blob_writer_t&) const override;
        ko from_blob(blob_reader_t&) override;

    public:
        hash_t address;
        locking_program_input_t locking_program_input;
        string key;
        string value;
    };

    static ostream& operator << (ostream& os, const cash::map_tx& t) {
        os << t.encode();
        return os;
    }

}

