#pragma once
#include <us/gov/io/seriable.h>
#include <vector>

namespace us::gov::cash {

    struct sigcode_section_t final: io::seriable {
 
        struct side_t: vector<uint8_t> {
            void dump(const string& prefix, ostream&) const;
            void dump_line(ostream&) const;
        };

        sigcode_section_t() {}
        sigcode_section_t(const sigcode_section_t& other): inputs(other.inputs), outputs(other.outputs) {}
        sigcode_section_t& operator = (const sigcode_section_t& other) {
            inputs = other.inputs;
            outputs = other.outputs;
            return *this;
        }
        ~sigcode_section_t() override {}

        void dump(const string& prefix, ostream&) const;
        void dump_line(ostream&) const;

    public:
        size_t blob_size() const override;
        void to_blob(blob_writer_t&) const override;
        ko from_blob(blob_reader_t&) override;

    public:
        side_t inputs;
        side_t outputs;
    };

}

