#pragma once
#include <us/gov/types.h>
#include <us/gov/io/seriable_map.h>

namespace us::gov::cash {

    struct accounts_t;

    struct t_t final: io::seriable_map<hash_t, cash_t> {
        t_t();
        t_t(const t_t&);
        t_t& operator = (const t_t&) = delete;
        void dump(const string& prefix, const hash_t& addr, ostream&) const;
        void hash_data_to_sign(sigmsg_hasher_t&) const;
        void hash_data(hasher_t&) const;
        bool burn(const hash_t& token, const cash_t&);
        cash_t get_value(const hash_t& token) const;
        void set_supply(const hash_t& token, const cash_t& supply);
        void merge(const t_t&);
        void on_destroy(accounts_t& ledger);

    };

}

