#pragma once
#include "input_t.h"
#include <us/gov/io/seriable_vector.h>

namespace us::gov::cash::tx {

    struct inputs_t final: io::seriable_vector<input_t> {
        using b = io::seriable_vector<input_t>;

        void write_sigmsg(sigmsg_hasher_t&, const sigcode_section_t&) const;
        cash_t total() const;
        cash_t total_unsigned() const;
        void write_pretty(const string& prefix, ostream&) const;
        inline uint64_t uniq() const { return empty() ? 0 : begin()->uniq(); }
    };

}

