#pragma once
#include <us/gov/io/seriable.h>

namespace us::gov::cash::tx {

    struct output_t final: io::seriable {

        output_t();
        output_t(const hash_t& address, const cash_t& amount);
        output_t(const output_t&);

    public:
        void write_sigmsg(sigmsg_hasher_t&) const;
        void write_pretty(const string& prefix, ostream&) const;

    public:
        size_t blob_size() const override;
        void to_blob(blob_writer_t&) const override;
        ko from_blob(blob_reader_t&) override;

    public:
        hash_t address;
        cash_t amount;
    };

}

