#pragma once
#include <vector>
#include "section_t.h"
#include <us/gov/io/seriable_vector.h>

namespace us::gov::cash::tx {

    struct sections_t final: io::seriable_vector<section_t> {
        using b = io::seriable_vector<section_t>;

        void write_sigmsg(sigmsg_hasher_t&, const sigcode_t&) const;
        void write_pretty(const string& prefix, ostream&) const;
        bool check_amounts() const;
        const_iterator find(const hash_t& token) const;
        iterator find(const hash_t& token);
        uint64_t uniq() const { return empty() ? 0 : begin()->uniq(); }

    };

}

