#pragma once
#include <string>
#include "ko.h"

//---- LOGS component patching panel
#define CFG_LOGS__GOV_CONCUR 1
#define CFG_LOGS__GOV_CRYPTO 1
#define CFG_LOGS__GOV_IO 1
#define CFG_LOGS__GOV_SOCKET 1
#define CFG_LOGS__GOV_ID 1
#define CFG_LOGS__GOV_AUTH 1
#define CFG_LOGS__GOV_PEER 1
#define CFG_LOGS__GOV_RELAY 1
#define CFG_LOGS__GOV_DFS 1
#define CFG_LOGS__GOV_ENGINE 1
#define CFG_LOGS__GOV_ENGINE_AUTH 1
#define CFG_LOGS__GOV_ENGINE_CASH 1
#define CFG_LOGS__GOV_ENGINE_SYS 1
#define CFG_LOGS__GOV_ENGINE_TRADERS 1
#define CFG_LOGS__WALLET_ENGINE 1
#define CFG_LOGS__WALLET_WALLET 1
#define CFG_LOGS__WALLET_TRADER 1
#define CFG_LOGS__WALLET_TRADER_BOOTSTRAP 1
//------------------

//-----Network topology------------------------------------
//#define PRIVATE_PERMISSIONED_MESH
//#define PUBLIC_PERMISSIONLESS_MESH
//#define PUBLIC_PERMISSIONED_RING
#define PUBLIC_PERMISSIONLESS_MESH
#define LOGDIR "/var/log/plebble"
//---------------------------------------------------------

#define CFG_TEST 0
#define CFG_COPYRIGHT_LINE "2017-2022 root1m3@plebble.us 4NwEEwnQbnwB7p8yCBNkx9uj71ru"
#define CFG_COPYRIGHT_LINE2 "This program comes with ABSOLUTELY NO WARRANTY. For details type 'show w'."
#define CFG_COPYRIGHT_LINE3 "This is free software, and you are welcome to redistribute it under certain conditions. Type 'show c' for details."
#define CFG_LICENSE_FILE "/var/plebble/LICENSE"
#define AUTOMATIC_UPDATES_PUBKEY "ysMCfLj9wt9ZdaaRaNtCS2WUJh8T5kvrh4ihHARKiTH1"
#define NODEMASTER_PUBKEY ""
#define AUTOMATIC_UPDATES_ACCOUNT "4NwEEwnQbnwB7p8yCBNkx9uj71ru"
#define GOVUSER "gov"
#define BRANDID "PuxQ2g"
#define PLATFORM "plebble"
#define DATADIR ".plebble"
#define LAYOFF_DAYS 20
#define UGAS "WATER"
#define LGAS "water"
#define CFG_COUNTERS 0
#define CFG_CONNECTION_LOG 0

//Mesh Topology
#define CFG_MAX_NODES 200
#define CFG_MAX_NODES_PER_IP 6
#define CFG_ENABLE_SHARDING 0
#define CFG_SHARD_SIZE 32

#define CFG_CHANNEL 0
#define CFG_MAX_SUBSIDY 500000000
#define CFG_MAX_SIZE_DATAGRAM 60000000
#define CFG_LOGS 0
#define CFG_PORT 16672
#define CFG_PPORT 16672
#define CFG_WALLET_PORT 16673
#define CFG_WALLET_PPORT 16673
#define CFG_HMI_READY_TIMEOUT_SECS 1
#define CFG_MUTATION_PERIOD_SECS 300
#define CFG_AUTH_TIMEOUT_SECS 5
#define CFG_SENDQ_WMH 1000
#define CFG_SENDQ_SCHUNK 1500
#define CFG_DGRAM_ROUNDTRIP_TIMEOUT_SECS 5
#define CFG_REPORT_REASON 1
#define CFG_FCGI 0
#define CFG_BLOB_VERSION 10
#define CFG_ANDROID_BLOB_ID "F5a1povb"
#define CFG_API_V__GOV 8
#define CFG_API_V__WALLET 11
#define CFG_MONOTONIC_VERSION_FINGERPRINT 9

#ifdef PUBLIC_PERMISSIONLESS_MESH
    #define CFG_PUBLIC_NETWORK
    #define CFG_PERMISSIONLESS_NETWORK
    #define CFG_TOPOLOGY_MESH
#endif

#ifdef PRIVATE_PERMISSIONED_MESH
    #define CFG_PRIVATE_NETWORK
    #define CFG_PERMISSIONED_NETWORK
    #define CFG_TOPOLOGY_MESH
#endif

#ifdef PUBLIC_PERMISSIONED_RING
    #define CFG_PUBLIC_NETWORK
    #define CFG_PERMISSIONED_NETWORK
    #define CFG_TOPOLOGY_RING
#endif

#ifdef CFG_PUBLIC_NETWORK
#ifdef CFG_PRIVATE_NETWORK
#error conflicting network type
#endif
#endif

#ifdef CFG_PERMISSIONED_NETWORK
#ifdef CFG_PERMISSIONLESS_NETWORK
#error conflicting authority type
#endif
#endif

#ifdef CFG_TOPOLOGY_RING
#ifdef CFG_TOPOLOGY_MESH
#error conflicting topologies
#endif
#endif

#ifdef PRIVATE_PERMISSIONED_MESH
    #define TOPOLOGY "private permissioned mesh"
#endif
#ifdef PUBLIC_PERMISSIONLESS_MESH
    #define TOPOLOGY "public permissionless mesh"
#endif
#ifdef PUBLIC_PERMISSIONED_RING
    #define TOPOLOGY "public permissionless ring"
#endif

// unless a release build, disable 'final' keyword so tests can be compiled.
#if CFG_TEST == 0
    #define final_ final
#else
    #define final_
#endif

#define HAVE_CFG

