#pragma once
#include "app.h"
#include <map>
#include <iostream>
#include <us/gov/io/seriable.h>

namespace us::gov::engine {

    struct apps_t final: map<appid_t, app*>, virtual io::seriable {
        ~apps_t();
        void dump(const string& prefix, ostream&) const;
        void full_dump(const string& prefix, int detail, ostream&) const;
        ko shell_command(appid_t, istream&, ostream&);
        void process(const evidence&);

    public:
        ko from_blob(blob_reader_t&) override;
        size_t blob_size() const override;
        void to_blob(blob_writer_t&) const override;
    };

}

