#pragma once
#include <us/gov/config.h>
#ifdef CFG_PERMISSIONED_NETWORK

#include <us/gov/types.h>
#include <us/gov/engine/evidence.h>
#include <us/gov/socket/datagram.h>
#include <us/gov/engine/signed_data.h>

namespace us::gov::engine {

    struct acl_tx: evidence, signed_data {
        using b = evidence;
        using s = signed_data;

        static constexpr eid_t eid{1};

        acl_tx();
        ~acl_tx() override;
        acl_tx(const string&) = delete;

        string name() const override { return "engine::acl_tx"; }
        void hash_data_to_sign(sigmsg_hasher_t&) const override;
        void hash_data(ripemd160&) const override;
        bool verify(ostream&) const override;
        void write_pretty_en(ostream&) const override;
        void write_pretty_es(ostream&) const override;
        uint64_t uniq() const override { return *reinterpret_cast<const uint64_t*>(&signature); }

    public:
        size_t blob_size() const override;
        void to_blob(blob_writer_t&) const override;
        ko from_blob(blob_reader_t&) override;

    public:
        hash_t addr;
        bool allow;
    };

}

#endif

