#pragma once
#include <us/gov/engine/evidence.h>

namespace us::gov::engine::auth {

    struct node_address_tx final: engine::evidence {
        using b = engine::evidence;

        static constexpr eid_t eid{0};

        node_address_tx();
        node_address_tx(const hash_t& pkh, uint32_t net_addr, uint16_t pport);
        void write_pretty_en(ostream&) const override;
        void write_pretty_es(ostream&) const override;
        string name() const override { return "auth::app::node_address"; }
        void dump(const string& prefix, ostream&) const;
        uint64_t uniq() const override { return 0; }

    public:
        size_t blob_size() const override;
        void to_blob(blob_writer_t&) const override;
        ko from_blob(blob_reader_t&) override;

    public:
        hash_t pkh;
        uint32_t net_addr;
        uint16_t pport;
    };

}

