#pragma once
#include <us/gov/config.h>
#include <us/gov/bgtask.h>
#include "calendar.h"

namespace us::gov::engine {

    struct evidence_processor: bgtask {
        using t = bgtask;

        evidence_processor();
        ~evidence_processor();

        void process_evidences(uint64_t maxts);
        void run();
        void wait();
        void wait_new_cycle();
        void onwakeup();
        virtual void on_block_closure(uint64_t) = 0;
        virtual void exec_evidence(const evidence&) = 0;
        virtual bool ready_for_block_opening(uint64_t) const = 0;

        calendar_t calendar;

    private:
        mutable condition_variable cv;

    #if CFG_LOGS == 1
    public:
        string logdir;
    #endif
    };

}

