#pragma once
#include "net.h"
#include "api.h"

namespace us::gov::engine {

    struct rpc_peer_t: net::rpc_peer_t, caller_api {
        using b = net::rpc_peer_t;

        using b::rpc_peer_t;

        inline ko authorize(const pub_t&, pin_t, request_data_t&) override { return ok; }
        bool process_work(datagram*) override;
        void dump(const string& prefix, ostream&) const;
        void dump_all(const string& prefix, ostream&) const override;
        svc_t translate_svc(svc_t svc0, bool inbound) const override;

        #include <us/api/generated/gov/c++/engine/cllr_override>
        #include <us/api/generated/gov/c++/engine_auth/cllr_override>
        #include <us/api/generated/gov/c++/cash/cllr_override>
        #include <us/api/generated/gov/c++/traders/cllr_override>
        #include <us/api/generated/gov/c++/sys/cllr_override>
    };

}

