#pragma once
#include <us/gov/socket/daemon_t.h>
#include <us/gov/socket/rpc_daemon_t.h>
#include <us/gov/crypto/types.h>

#include "peer_t.h"
#include "daemon0_t.h"

namespace us::gov::id {

    struct daemon_t: base_ns::daemon_t, daemon0_t {
        using b = base_ns::daemon_t;

        daemon_t(channel_t channel, port_t, pport_t, int workers);

        bool is_duplicate(const pub_t&) const;
        void disconnect(const pub_t&, seq_t seq, const reason_t&);
        //socket::client* create_client(sock_t sock) override;

    public:
        void dump(const string& prefix, ostream&) const;
        void dump_all(const string& prefix, ostream&) const override;

    public:
        pport_t pport; //Public/Published/advertised/gossip'd TCP port for reaching up (router).

    };

}

