#pragma once

#include "writable.h"
#include "readable.h"
//#include "blob_reader_t.h"
//#include "blob_writer_t.h"
#include "types.h"

namespace us::gov::io {

    struct blob_writer_t;
    struct blob_reader_t;

    struct seriable: readable, writable {
        using blob_writer_t = us::gov::io::blob_writer_t;
        using blob_reader_t = us::gov::io::blob_reader_t;
        using serid_t = readable::serid_t;

        using writable::serial_id;
    };

    static_assert(std::is_convertible<seriable*, writable*>::value, "KO 74822");
    static_assert(std::is_convertible<seriable*, readable*>::value, "KO 74823");


}

