#pragma once

#ifdef __GNUC__
# if (__GNUC__ >= 3)
#  define likely(x)     __builtin_expect ((x), 1)
#  define unlikely(x)   __builtin_expect ((x), 0)
# else
#  define likely(x)     (x)
#  define unlikely(x)   (x)
# endif
#else
# ifdef __clang__
#  define likely(x)     __builtin_unpredictable((x), 1)
#  define unlikely(x)   __builtin_unpredictable((x), 0)
# else
#  define likely(x)      (x)
#  define unlikely(x)    (x)
# endif
#endif

