#pragma once
//#include <unordered_set>
#include <array>
#include <cstdint>
//#include <mutex>

//#include <us/gov/types.h>
//#include <us/gov/crypto/types.h>
//#include <us/gov/socket/types.h>
#include "grid_t.h"

namespace us::gov::peer {

    struct peer_t;

    //static constexpr int clique_dimensions{1};
    //static constexpr uint8_t clique_dimension_mask{};
    
    struct clique_t: vector<grid_t*> {

        clique_t();

        void resize(uint8_t dimensions, uint8_t edges);

        peer::peer_t* pick_one();
        bool add(peer_t&, bool check_unique);
        void dump(ostream&) const;
        void watch(ostream&) const;
        vector<hostport_t> list() const;
        bool ended(peer_t*);
        void test_connectivity();

        uint8_t dimension_mask{0b00000000};

    };

}

