#pragma once
#include <unordered_set>
#include <vector>
#include <mutex>

#include <us/gov/types.h>
#include <us/gov/crypto/types.h>
#include <us/gov/socket/types.h>

namespace us::gov::peer {

    struct peer_t;

    struct grid_t: vector<peer_t*> {

        grid_t() {}
        grid_t(const grid_t&) = delete;

        bool add(peer_t&, bool check_unique);
        bool ended(peer_t*);
        void dump(ostream&) const;
        void watch(ostream&) const;
        peer_t* prepare_worker_send(unordered_set<const peer_t*>& visited);
        bool find(const hash_t&) const;
        int num_edges_minage(int secs_old) const;
        peer_t* pick_one();

        mutable mutex mx_;


    };

}

