#pragma once
#include <atomic>
#include "types.h"

namespace us::gov::socket {

    struct busyled_t {

        busyled_t();
        ~busyled_t();

        struct handler_t {
            virtual ~handler_t() {}
            virtual void on_busy() = 0;
            virtual void on_idle() = 0;
        };

        void set();
        void reset();
        void set_handler(handler_t*);

    private:
        handler_t* handler{nullptr};
        atomic<int> ref{0};
    };

}

