#pragma once
#include <string>
#include <unordered_set>
#include <us/gov/bgtask.h>
#include <us/gov/config.h>

namespace us::gov::socket {

    struct client;

}

namespace us::gov::socket::multipeer {

    struct gc_t final: unordered_set<client*>, wbgtask {
        using t = wbgtask;

        gc_t();
        ~gc_t();

        void add_(client*);
        void dump(ostream&) const;
        void clear();
        void task_init() override;
        void task() override;
        void task_cleanup() override;
        void collect() override;
        void onwakeup();

    public:
        mutable mutex mx;
        condition_variable cv;

        #if CFG_LOGS == 1
            string logdir;
        #endif
    };

}

