#pragma once
#include <condition_variable>
#include <mutex>
#include <unordered_map>

#include <us/gov/ko.h>
#include <us/gov/socket/types.h>

namespace us::gov::socket {

    using namespace us;
    struct datagram;
    struct client;
    struct caller_daemon_t;

    struct rendezvous_t final: unordered_map<seq_t, datagram*> {

        static const char* KO_3029, *KO_20190;
        static uint16_t dgram_roundtrip_timeout_secs;

    public:
        rendezvous_t(caller_daemon_t&);
        ~rendezvous_t();

        bool arrived(datagram *);
        void flush();
        pair<ko, datagram*> sendrecv(client&, datagram*, string& remote_error);

    public:
        caller_daemon_t& caller_daemon;
        seq_t next_seq{0};
        mutex mx;
        condition_variable cv;
        bool finished{false};
    };

}

