#pragma once
#include <mutex>
#include <us/gov/io/seriable.h>
#include "sensors_t.h"

namespace us::gov::sys {

    struct db_t final: io::seriable {
        db_t();
        db_t(const db_t&) = delete;
        db_t(db_t&& other);
        ~db_t();

        db_t& operator = (const db_t&) = delete;

        void dump(const string& prefix, ostream& os) const;
        void clear();

    public:
        size_t blob_size() const override;
        void to_blob(blob_writer_t&) const override;
        ko from_blob(blob_reader_t&) override;

    public:
        mutable mutex mx;
        sensors_t sensors;
    };

}

