#pragma once
#include <us/gov/types.h>
#include "sensors_t.h"
#include "local_delta.h"

namespace us::gov::sys {

    struct delta: engine::app::delta {
        using b = engine::app::delta;

        struct merger final: sensors_t {
            void merge(const sensor_t&);
        };

        delta();
        delta(const delta&) = delete;
        delta& operator = (const delta&) = delete;
        ~delta() override;

        uint64_t merge(engine::app::local_delta*) override;
        void end_merge() override;

    public:
        void dump(const string& prefix, ostream&) const override;

    public:
        size_t blob_size() const override;
        void to_blob(blob_writer_t&) const override;
        ko from_blob(blob_reader_t&) override;

    public:

        local_delta g;
        merger m;
    };

}

