#pragma once
#include <us/gov/io/seriable.h>
#include <us/wallet/wallet/handler_api.h>


#include "dto.h"
#include "types.h"
#include "protocol.h"

namespace us::wallet::engine {

    struct peer_t;

    using blob_writer_t = gov::io::blob_writer_t;
    using blob_reader_t = gov::io::blob_reader_t;

    struct caller_api: virtual dto, us::wallet::wallet::caller_api {

        #include <us/api/generated/wallet/c++/engine/cllr_purevir>
        #include <us/api/generated/wallet/c++/pairing/cllr_purevir>
        #include <us/api/generated/wallet/c++/r2r/cllr_purevir>

    };

    struct api: caller_api {

        #include <us/api/generated/wallet/c++/engine/hdlr_purevir>
        #include <us/api/generated/wallet/c++/pairing/hdlr_purevir>
        #include <us/api/generated/wallet/c++/r2r/hdlr_purevir>

    };

}

