#pragma once
#include <string>
#include "types.h"

namespace us { namespace wallet { namespace engine {

    struct device_t {

        static string default_name;

        device_t() {}
        device_t(const pub_t& pub, const string& subhome, const string& name): pub(pub), name(name), subhome(subhome) {}
        device_t(const string& subhome, const string& name): name(name), subhome(subhome) {}
        device_t(const device_t& other): pub(other.pub), name(other.name), subhome(other.subhome) {}

    public:
        void to_stream(ostream&) const;
        static pair<ko, device_t> from_streamX(istream&);
        void dump(ostream&) const;
        pin_t decode_pin() const;
        void encode_pin(pin_t);

    public:
        string name;
        pub_t pub;
        string subhome;
    };

}}}

