#pragma once
#include <mutex>

#include <us/wallet/trader/endpoint_t.h>

#include "protocols_t.h"
#include "a_t.h"

namespace us::wallet::engine {
    struct peer_t;
}

namespace us::wallet::trader {
    struct trader_t;
}

namespace us::wallet::trader::bootstrap {
    using namespace std;

    struct bootstrapper_t;

    struct dialogue_a_t {
        using personality_proof_t = trader::personality::proof_t;
        using endpoint_t = trader::endpoint_t;
        using peer_t = engine::peer_t;

        static constexpr auto KO_43342 = "KO_43342 Out of sequence.";

        dialogue_a_t(bootstrapper_t& parent);
        ~dialogue_a_t();

        struct state_t {
            int seq{0};
        };

        ko initiate(peer_t&, const string& wloc);
        ko handshake(peer_t&, a1_t&&);
        ko handshake(peer_t&, a2_t&&);
        ko handshake(peer_t&, a3_t&&);
        ko update_peer(peer_t&, ch_t&&);
        ko update_peer2(peer_t&, ch_t&&);
        void reset();
        state_t* release_();

    public:
        state_t* state{nullptr};
        mutex mx;
        bootstrapper_t& parent;
    };

}

