#pragma once

#include <mutex>

#include <us/wallet/trader/ch_t.h>
#include <us/wallet/trader/protocol_selection_t.h>

#include "b_t.h"

namespace us::wallet::engine {
    struct peer_t;
}

namespace us::wallet::trader {
    struct trader_t;
}

namespace us::wallet::trader::bootstrap {

    using namespace std;
    struct bootstrapper_t;

    struct dialogue_b_t {
        using ch_t = trader::ch_t;
        using peer_t = engine::peer_t;

        static constexpr auto KO_43343 = "KO_43343 Out of sequence.";

        struct state_t {
            int seq{0};
        };

        dialogue_b_t(bootstrapper_t& parent);
        ~dialogue_b_t();

        ko initiate(peer_t&, protocol_selection_t&&, ch_t&);
        ko handshake(peer_t&, b1_t&&);
        ko handshake(peer_t&, b2_t&&);
        ko handshake(peer_t&, b3_t&&);
        ko update_peer(peer_t&, ch_t&& ch, bool b = false);
        void reset();
        state_t* release_();

        state_t* state{nullptr};
        mutex mx;
        bootstrapper_t& parent;
    };

}

