#pragma once
#include <us/gov/crypto/ripemd160.h>

#include <us/wallet/engine/peer_t.h>

#include "bootstrapper_t.h"

namespace us::wallet::trader::bootstrap {

    struct follower_t final: bootstrapper_t {
        using b = bootstrapper_t;
        using peer_t = us::wallet::engine::peer_t;
        using hash_t = us::gov::crypto::ripemd160::value_type;

        follower_t(const hash_t& trade_id, peer_t&);
        bool initiator() const override { return false; }
        pair<ko, hash_t> start(trader_t&) override;
        void offline() override;
        ko on_a(int) override;
        ko on_c(int) override;

        peer_t& peer;
    };

}

