#pragma once
#include <us/gov/io/seriable.h>

#include "kv.h"

namespace us::wallet::trader {

    using namespace std;

    struct ch_t;
    using params_t = kv;

    struct local_params_t: gov::io::seriable {
        using ch_t = trader::ch_t;
        void load(const string& dir, ch_t&);
        void save(const string& dir);
        void clear();
        void dump(const string& prefix, ostream&) const;

    public:
        size_t blob_size() const override;
        void to_blob(blob_writer_t&) const override;
        ko from_blob(blob_reader_t&) override;

    public:
        params_t shared;
        params_t priv;
    };

    using remote_params_t = params_t;

}

