#pragma once

#include <mutex>
#include <string>

#include <us/gov/config.h>
#include <us/gov/ko.h>
#include <us/wallet/trader/bookmarks_t.h>

#include "types.h"

namespace us::wallet::wallet {

    struct bookmarksman_t final: us::wallet::trader::bookmarks_t {
        using b = us::wallet::trader::bookmarks_t;
        using bookmark_t = us::wallet::trader::bookmark_t;

        bookmarksman_t();
        ko init(const string& home);
        ko load();
        ko save();
        ko load_();
        ko save_();
        blob_t blob() const;
        ko add(const string& name, bookmark_t&&);
        ko remove(const string& key);

        string home;
        mutable mutex mx;
    };

}

