package plebble.trader;
import androidx.appcompat.app.ActionBarDrawerToggle;                                           // ActionBarDrawerToggle
import us.gov.crypto.base58;                                                                   // base58
import us.gov.io.blob_reader_t;                                                                // blob_reader_t
import android.os.Build;                                                                       // Build
import android.os.Bundle;                                                                      // Bundle
import us.gov.socket.datagram;                                                                 // datagram
import static us.gov.crypto.ripemd160.hash_t;                                                  // hash_t
import static us.gov.io.types.*;                                                               // *
import static us.ko.*;                                                                         // *
import static us.stdint.*;                                                                     // *
import static us.tuple.*;                                                                      // *
import us.ko;                                                                                  // ko
import android.view.Menu;                                                                      // Menu
import android.view.MenuItem;                                                                  // MenuItem
import us.pair;                                                                                // pair
import us.wallet.protocol;                                                                     // protocol
import android.widget.RelativeLayout;                                                          // RelativeLayout
import androidx.annotation.RequiresApi;                                                        // RequiresApi
import us.string;                                                                              // string
import android.widget.TextView;                                                                // TextView
import android.widget.Toast;                                                                   // Toast
import androidx.appcompat.widget.Toolbar;                                                      // Toolbar
import android.view.View;                                                                      // View

public final class tradelog extends activity implements datagram_dispatcher_t.handler_t  {


    @RequiresApi(api = Build.VERSION_CODES.O)
    @Override protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        set_content_layout(R.layout.activity_tradelog);
        tvlog = findViewById(R.id.log);
        Bundle bundle = getIntent().getExtras();
        tid = new hash_t(bundle.getByteArray("tid"));
        String ct = bundle.getString("content_type");
        if (ct.equals("data")) {
            content_type = ct;
            toolbar.setTitle(getResources().getString(R.string.datatrade) + " " + tid.encode());
        }
        else if (ct.equals("log")) {
            toolbar.setTitle("Log trade #" + tid.encode());
        }
        toolbar_button refresh = (toolbar_button) findViewById(R.id.refresh);
        refresh.setOnClickListener(new View.OnClickListener() {
            @Override public void onClick(View view) {
                fetch();
            }
        });
        dispatchid = a.hmi().dispatcher.connect_sink(this);
    }

    @Override public void onDestroy() {
        super.onDestroy();
        a.hmi().dispatcher.disconnect_sink(dispatchid);
    }

   @Override public void onPause() {
        super.onPause();
    }

    @Override public void onResume() {
        super.onResume();
        fetch();
    }

    @Override public void on_push(final hash_t target_tid, final uint16_t code, final byte[] payload) {
        if(!tid.equals(target_tid)) return;
        switch(code.value) {
            case us.wallet.trader.trader_t.push_log: {
                if (content_type.equals("log")) {
                    string s = new string();
                    ko r = blob_reader_t.parse(new blob_t(payload), s);
                    if (is_ko(r)) {
                        setlog(r.msg);
                        return;
                    }
                    setlog(s.value);
                }
            }
            break;
            case us.wallet.trader.trader_t.push_data: {
                if (content_type.equals("data")) {
                    string s = new string();
                    ko r = blob_reader_t.parse(new blob_t(payload), s);
                    if (is_ko(r)) {
                        setlog(r.msg);
                        return;
                    }
                    setlog(s.value);
                }
            }
            break;
        }
    }

    void setlog(final String txt) {
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                String l = txt.replace('\r','\n');
                tvlog.setText(l);
            }
        });
    }

    void fetch() {
        if (content_type.equals("log")) {
            tvlog.setText("retrieving log...");
            a.hmi().command_trade(tid, "show log");
        }
        else if (content_type.equals("data")) {
            tvlog.setText("retrieving data...");
            a.hmi().command_trade(tid, "show data");
        }
    }

    hash_t tid;
    private TextView tvlog;
    String content_type = "log";
    int dispatchid;
}

