package plebble.trader;
import androidx.appcompat.app.ActionBarDrawerToggle;                                           // ActionBarDrawerToggle
import androidx.appcompat.app.AppCompatActivity;                                               // AppCompatActivity
import us.gov.crypto.base58;                                                                   // base58
import us.gov.io.blob_reader_t;                                                                // blob_reader_t
import us.wallet.trader.bookmark_t;                                                            // bookmark_t
import com.google.android.material.bottomsheet.BottomSheetBehavior;                            // BottomSheetBehavior
import android.os.Build;                                                                       // Build
import android.os.Bundle;                                                                      // Bundle
import static us.wallet.trader.chat.chat_t;                                                    // chat_t
import android.graphics.Color;                                                                 // Color
import android.widget.CompoundButton;                                                          // CompoundButton
import android.content.Context;                                                                // Context
import us.gov.socket.datagram;                                                                 // datagram
import us.wallet.trader.data_t;                                                                // data_t
import us.wallet.trader.endpoint_t;                                                            // endpoint_t
import androidx.fragment.app.Fragment;                                                         // Fragment
import androidx.fragment.app.FragmentTransaction;                                              // FragmentTransaction
import android.widget.FrameLayout;                                                             // FrameLayout
import static us.gov.crypto.ripemd160.hash_t;                                                  // hash_t
import android.widget.ImageView;                                                               // ImageView
import static us.gov.io.types.*;                                                               // *
import static us.stdint.*;                                                                     // *
import static us.tuple.*;                                                                      // *
import android.content.Intent;                                                                 // Intent
import static us.ko.is_ko;                                                                     // is_ko
import us.ko;                                                                                  // ko
import android.widget.LinearLayout;                                                            // LinearLayout
import com.google.android.material.button.MaterialButton;                                      // MaterialButton
import android.view.Menu;                                                                      // Menu
import android.view.MenuItem;                                                                  // MenuItem
import androidx.annotation.NonNull;                                                            // NonNull
import static us.ko.ok;                                                                        // ok
import us.pair;                                                                                // pair
import us.wallet.protocol;                                                                     // protocol
import us.wallet.trader.qr_t;                                                                  // qr_t
import android.widget.RelativeLayout;                                                          // RelativeLayout
import androidx.annotation.RequiresApi;                                                        // RequiresApi
import us.string;                                                                              // string
import android.widget.Switch;                                                                  // Switch
import android.widget.TextView;                                                                // TextView
import java.util.Timer;                                                                        // Timer
import java.util.TimerTask;                                                                    // TimerTask
import android.widget.Toast;                                                                   // Toast
import android.media.ToneGenerator;                                                            // ToneGenerator
import androidx.appcompat.widget.Toolbar;                                                      // Toolbar
import android.view.View;                                                                      // View

public class trader extends activity implements datagram_dispatcher_t.handler_t  {


    public synchronized data_t get_data() {
        return data_;
    }

    public synchronized String get_src_data() {
        return src_data;
    }

    private synchronized void set_data(String src, data_t x) {
        src_data = src;
        data_ = x;
    }

    @Override protected void onSaveInstanceState(Bundle outState) {
        outState.putString("WORKAROUND_FOR_BUG_19917_KEY", "WORKAROUND_FOR_BUG_19917_VALUE");
        super.onSaveInstanceState(outState);
    }

    @RequiresApi(api = Build.VERSION_CODES.O)
    @Override protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        set_content_layout(R.layout.activity_trader);
        tradeid = findViewById(R.id.tradeid);
        if (getIntent().hasExtra("tid")) {
            Bundle bundle = getIntent().getExtras();
            tid = new hash_t(bundle.getByteArray("tid"));
        }
        else {
            finish();
        }
        toolbar.setTitle(getResources().getString(R.string.trader) + " #" + tid.encode());
        tradeid.setText("id " + tid.encode());
        procol = findViewById(R.id.procol);
        procol_cap = findViewById(R.id.procol_cap);
        toolbar_button refresh = findViewById(R.id.refresh);
        bottom_sheet = findViewById(R.id.bottom_sheet);
        button_chat = findViewById(R.id.button_chat);
        button_chat.setVisibility(View.VISIBLE);
        sheetBehavior = BottomSheetBehavior.from(bottom_sheet);
        sheetBehavior.setState(BottomSheetBehavior.STATE_HIDDEN);
        sheetBehavior.setSkipCollapsed(true);

        toolbar_button action = findViewById(R.id.action);
        action.setVisibility(View.GONE);
        chat_handlers();
        vf = 0;
        ft = new fragment_trader();
        ft.setArguments(getIntent().getExtras());
        getSupportFragmentManager().beginTransaction().add(R.id.fragment_container, ft).commitAllowingStateLoss();
        refresh.setOnClickListener(new View.OnClickListener() {
            @Override public void onClick(View view) {
                invalidate_data_fetch0();
            }
        });
        refresh.setVisibility(View.VISIBLE);
        procol.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if (cur_protocol == null) {
                }
                else {
                    if (procol.isChecked()) {
                        if (vf != 1) {
                            vf = 1;
                        }
                    }
                    else {
                        if (vf != 0) {
                            vf = 0;
                        }
                    }
                }
                refresh();
            }
        });
    }

    @Override public void onPause() {
        super.onPause();
        if (!a.has_hmi()) {
            dispatchid = -1;
        }
        else {
            if (dispatchid != -1) {
                a.hmi().dispatcher.disconnect_sink(dispatchid);
            }
        }
    }

    @Override public void onResume() {
        super.onResume();
        if (!a.has_hmi()) {
            dispatchid = -1;
        }
        else {
            dispatchid = a.hmi().dispatcher.connect_sink(this);
            invalidate_data_fetch0();
        }
    }

    @Override public void on_push(final hash_t target_tid, final uint16_t code, final byte[] payload) {
        if (!tid.equals(target_tid)) {
            return;
        }
        switch(code.value) {
            case us.wallet.trader.trader_t.push_data: {
                string s = new string();
                ko r = us.gov.io.blob_reader_t.parse(new blob_t(payload), s);
                if (is_ko(r)) {
                    return;
                }
                setdata__worker(s.value);
            }
            break;
            case us.wallet.trader.trader_t.push_roles: {
                us.wallet.trader.roles_t roles = new us.wallet.trader.roles_t();
                ko r = us.gov.io.blob_reader_t.parse(new blob_t(payload), roles);
                if (is_ko(r)) {
                    return;
                }
                setroles(roles);
            }
            break;
            case us.wallet.trader.trader_t.push_chat: {
                openchat__worker(payload);
            }
            break;
            case us.wallet.trader.trader_t.push_cert: {
                hash_t nft = new hash_t();
                ko r = us.gov.io.blob_reader_t.parse(new blob_t(payload), nft);
                if (is_ko(r)) {
                    return;
                }
                recv_cert__worker(nft);
            }
            break;
            case us.wallet.trader.trader_t.push_killed: {
                archive();
            }
            break;
        }
    }

    void chat_handlers() {
        button_chat.setOnClickListener(new View.OnClickListener() {
            @Override public void onClick(View view) {
                int st = sheetBehavior.getState();
                if (st == BottomSheetBehavior.STATE_HIDDEN) {
                    sheetBehavior.setState(BottomSheetBehavior.STATE_EXPANDED); //BottomSheetBehavior.BottomSheetBehavior);
                }
                else if (st == BottomSheetBehavior.STATE_EXPANDED) {
                    sheetBehavior.setState(BottomSheetBehavior.STATE_HIDDEN);
                }
                else if (st == BottomSheetBehavior.STATE_COLLAPSED) {
                    sheetBehavior.setState(BottomSheetBehavior.STATE_EXPANDED);
                }
                else {
                    sheetBehavior.setState(BottomSheetBehavior.STATE_HIDDEN);
                }
                //refresh();
            }
        });

        sheetBehavior.setBottomSheetCallback(new BottomSheetBehavior.BottomSheetCallback() {
            @Override public void onStateChanged(@NonNull View view, int newState) {
                switch (newState) {
                    case BottomSheetBehavior.STATE_HIDDEN:
                        break;
                    case BottomSheetBehavior.STATE_EXPANDED: {
                            openchat(null);
                        }
                        break;
                    case BottomSheetBehavior.STATE_COLLAPSED:
                        break;
                    case BottomSheetBehavior.STATE_DRAGGING:
                        break;
                    case BottomSheetBehavior.STATE_SETTLING:
                        break;
                }
                //refresh();
            }

            @Override public void onSlide(@NonNull View view, float v) {}
        });
    }

    void recv_cert__worker(final hash_t nft) {
        toast__worker("A certificate has been received!: " + nft.encode());
    }

    void openchat__worker(final byte[] chatpayload) {
        runOnUiThread(new Runnable() {
            @Override public void run() {
                openchat(chatpayload);
            }
        });
    }

    public String getendpoint() {
        data_t data = get_data();
        String endpoint = data.find("remote_endpoint");
        if (endpoint == null) {
            endpoint = "";
        }
        return endpoint;
    }

    public String peer_moniker() {
        data_t data = get_data();
        String s = data.find("peer_moniker");
        if (s == null) {
            s = "Anonymous";
        }
        return s;
    }

    public hash_t gettid() {
        return tid;
    }

    boolean setroles(final us.wallet.trader.roles_t roles) {
        this.roles = roles;
        if (forward_roles != null) {
            final fragment_trader fr = forward_roles;
            final us.wallet.trader.roles_t r = this.roles;
            forward_roles = null;
            runOnUiThread(new Runnable() {
                @Override public void run() {
                    fr.select_roles(r);
                }
            });
        }
        return true;
    }

    boolean setdata0(final String sdata) {
        data_t dat = new data_t();
        ko r = dat.from(sdata);
        if (is_ko(r)) {
        }
        set_data(src_data, dat);
        return true;
    }

    boolean setdata1(final String sdata) {
        if (!setdata0(sdata)) {
            return false;
        }
        data_t data = get_data();
        if (data == null) {
            cur_protocol = null;
            vf = 0;
        }
        else {
            String r = data.find("protocol");
            if (r == null) {
                cur_protocol = null;
                vf = 0;
            }
            else {
                if (r.equals("not set")) {
                    cur_protocol = null;
                    vf = 0;
                }
                else {
                    if (!r.equals(cur_protocol)) {
                        cur_protocol = r;
                        vf = 1;
                    }
                }
            }
            String pt = data.find("parent_trade");
            if (pt == null) {
                parent_trade = new hash_t(0);
            }
            else {
                parent_trade = new hash_t(base58.decode(pt));
            }
        }
        return true;
    }

    boolean setdata__worker(final String sdata) {
        setdata1(sdata);
        runOnUiThread(new Runnable() {
            @Override public void run() {
                refresh();
            }
        });
        return true;
    }

    void get_sourceshit_qrs(String key, Context ctx) {
        if (command_show_param_qrs(key, ctx)) {
            return;
        }
        request_item_qrs(key, ctx); //ask other node
    }

    void get_sourceshit(String key, Context ctx) {
        if (command_show_param(key, ctx)) {
            return;
        }
        request_item(key, ctx);
    }

    void on_redirect(final bookmark_t redirect) {
        a.new_trade(tid, "", redirect.qr);
    }

    public void go_parent_trade() {
        if (parent_trade == null) {
            return;
        }
        if (parent_trade.is_zero()) {
            return;
        }
        Intent data = new Intent();
        a.go_trade(parent_trade);
    }

    public void setmode_loading() {
    }

    public void setmode_ready() {
    }

    public void setmode_wrong(final String reason) {
    }

    public void invalidate_data_fetch0() {
        if (!a.has_hmi()) {
            finish();
            return;
        }
        setmode_loading();
        set_data(null, null);
        a.hmi().command_trade(tid, "show data"); //backend will push data
    }

    public void refresh() {
        if (!a.has_hmi()) {
            finish();
            return;
        }
        super.refresh();
        if (get_data() == null) {
            setmode_wrong("KO 8675");
            return;
        }
        if (cur_protocol != null) {
            procol.setEnabled(true);
            if (vf == 1) {
                procol.setChecked(true);
                procol_cap.setText(" Role View - " + cur_protocol);
            }
            else {
                procol_cap.setText(" Trader View");
                procol.setChecked(false);
            }
        }
        else {
            procol.setChecked(false);
            procol.setEnabled(false);
            procol_cap.setText(" Trader View");
        }

        if (vf == 1) {
            if (!create_ui(cur_protocol)) {
                Toast.makeText(getApplicationContext(), "Cannot create UI " + cur_protocol, 6000).show();
            }
            else {
                getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, specialized_fragment).commitNowAllowingStateLoss(); //AllowingStateLoss();
            }
        }
        else {
            try {
                getSupportFragmentManager().beginTransaction().replace(R.id.fragment_container, ft).commitNowAllowingStateLoss(); //AllowingStateLoss();
            }
            catch(Exception e) {
                Toast.makeText(getApplicationContext(), getResources().getString(R.string.cannotcreatetraderUI), 6000).show();
                error_manager.manage(e, e.getMessage() + "    " + e.toString());
            }
        }

        if (vf == 0) {
            if (ft != null) {
                if (ft.getContext() != null) {
                    ft.refresh();
                }
            }
        }
        else {
            if (specialized_fragment != null) {
                if (specialized_fragment.getContext() != null) {
                    specialized_fragment.refresh();
                }
            }
        }
    }

    boolean create_ui__core0(String protocol) {
        if (protocol.equals("w2w w")) {
            if (specialized_fragment != null) {
                if (specialized_fragment instanceof fragment_w2w) {
                    return true;
                }
            }
            specialized_fragment = new fragment_w2w();
            return true;
        }
        if (protocol.equals("a2a a")) {
            if (specialized_fragment != null) {
                if (specialized_fragment instanceof fragment_a2a) {
                    return true;
                }
            }
            specialized_fragment = new fragment_a2a();
            return true;
        }
        if (protocol.equals("bid2ask bid")) {
            if (specialized_fragment != null) {
                if (specialized_fragment instanceof fragment_bid2ask_bid) {
                    return true;
                }
            }
            specialized_fragment = new fragment_bid2ask_bid();
            return true;
        }
        return false;
    }

    boolean create_ui__b2b(String protocol) {
        if (protocol.equals("b2b b")) {
            if (specialized_fragment != null) {
                if (specialized_fragment instanceof fragment_b2b) {
                    return true;
                }
            }
            specialized_fragment = new fragment_b2b();
            return true;
        }
        return false;
    }

    boolean create_ui__b2r(String protocol) {
        if (protocol.equals("b2r b")) {
            if (specialized_fragment != null) {
                if (specialized_fragment instanceof fragment_b2r_b) {
                    return true;
                }
            }
            specialized_fragment = new fragment_b2r_b();
            return true;
        }
        if (protocol.equals("b2r r")) {
            if (specialized_fragment != null) {
                if (specialized_fragment instanceof fragment_b2r_r) {
                    return true;
                }
            }
            specialized_fragment = new fragment_b2r_r();
            return true;
        }
        return false;
    }

    boolean create_ui__fanclub(String protocol) {
        if (protocol.equals("fan2fan fan")) {
            if (specialized_fragment != null) {
                if (specialized_fragment instanceof fragment_fan2fan) {
                    return true;
                }
            }
            specialized_fragment = new fragment_fan2fan();
            return true;
        }
        if (protocol.equals("fan2club fan")) {
            if (specialized_fragment != null) {
                if (specialized_fragment instanceof fragment_fan2club_fan) {
                    return true;
                }
            }
            specialized_fragment = new fragment_fan2club_fan();
            return true;
        }
        if (protocol.equals("fan2club club")) {
            if (specialized_fragment != null) {
                if (specialized_fragment instanceof fragment_fan2club_club) {
                    return true;
                }
            }
            specialized_fragment = new fragment_fan2club_club();
            return true;
        }
        return false;
    }

    boolean create_ui__katlas(String protocol) {
        if (protocol.equals("pat2slt pat")) {
            if (specialized_fragment != null) {
                if (specialized_fragment instanceof fragment_pat2slt_pat) {
                    return true;
                }
            }
            specialized_fragment = new fragment_pat2slt_pat();
            return true;
        }
        if (protocol.equals("pat2phy pat")) {
            if (specialized_fragment != null) {
                if (specialized_fragment instanceof fragment_pat2phy_pat) {
                    return true;
                }
            }
            specialized_fragment = new fragment_pat2phy_pat();
            return true;
        }
        if (protocol.equals("pat2ai pat")) {
            if (specialized_fragment != null) {
                if (specialized_fragment instanceof fragment_pat2ai_pat) {
                    return true;
                }
            }
            specialized_fragment = new fragment_pat2ai_pat();
            return true;
        }
        if (protocol.equals("pat2slt slt")) {
            if (specialized_fragment != null) {
                if (specialized_fragment instanceof fragment_pat2slt_slt) {
                    return true;
                }
            }
            specialized_fragment = new fragment_pat2slt_slt();
            return true;
        }
        if (protocol.equals("pat2rb pat")) {
            if (specialized_fragment != null) {
                if (specialized_fragment instanceof fragment_pat2rb_pat) {
                    return true;
                }
            }
            specialized_fragment = new fragment_pat2rb_pat();
            return true;
        }
        return false;
    }

    boolean create_ui(String protocol) {
        if (protocol == null) return false;
        if (create_ui__katlas(protocol)) {
            return true;
        }
        if (create_ui__fanclub(protocol)) {
            return true;
        }
        if (create_ui__b2r(protocol)) {
            return true;
        }
        if (create_ui__b2b(protocol)) {
            return true;
        }
        if (create_ui__core0(protocol)) {
            return true;
        }
        return false;
    }

    public void start_protocol(String selected_protocol) {
        a.start_protocol(tid, selected_protocol);
    }

    public void onActivityResult(int request_code, int result_code, final Intent data) {
        super.onActivityResult(request_code, result_code, data);
        if (result_code == AppCompatActivity.RESULT_CANCELED) {
            return;
        }
        if (request_code == PROTOCOLROLE_RESULT) {
            if (result_code == AppCompatActivity.RESULT_OK) {
                String prtocol = data.getDataString();
                start_protocol(prtocol);
            }
            else if (result_code == 111) {
                String KOreason = data.getDataString();
                toast(KOreason);
            }
            else if (result_code == 112) {
                String KOreason = data.getDataString();
                toast(getResources().getString(R.string.noptrotocolsavailable) + KOreason);
            }
            else {
                toast(getResources().getString(R.string.sorryselectionunsuccesful));
            }
            return;
        }
        if (request_code == CERT_VIEWER_RESULT) {
            if (result_code != doc_viewer.RESULT_OK) {
                return;
            }
            hash_t nft = (hash_t) data.getSerializableExtra("nft");
            if (nft == null) {
                toast("Null nft");
                return;
            }
            a.hmi().command_trade(tid, "send cert " + nft.encode());
            toast("Send certificate " + nft.encode());
            //a.hmi().command_trade(new hash_t(0), cmd);
            return;
        }
        specialized_fragment.onActivityResult(request_code, result_code, data);
    }

    boolean require_request(String key) {
        boolean rr = true;
        if (key.equals("log")) {
            rr = false;
        }
        return rr;
    }

    boolean command_show_param_qrs(final String key, Context ctx) {
        data_t data = get_data();
        String val = null;
        if (data != null) {
            val = data.find(key);
        }
        if (val != null) {
            if (val.equals("Y")) {
                a.hmi().command_trade(tid, "show " + key + " peer");
                return true;
            }
        }
        else {
        }
        return false;
    }

    boolean command_show_param(final String key, Context ctx) {
        boolean rr = require_request(key);
        if (rr) {
            data_t data = get_data();
            String val = null;
            if (data != null) {
                val = data.find(key);
            }
            if (val != null) {
                if (val.equals("Y")) {
                    a.hmi().command_trade(tid, "show " + key);
                    return true;
                }
            }
            else {
            }
        }
        else {
            a.hmi().command_trade(tid, "show " + key);
            return true;
        }
        return false;
    }

    void request_item_qrs(final String key, Context ctx) {
        a.hmi().command_trade(tid, "request qrs");
    }

    void request_item(final String key, Context ctx) {
        String request_verb = "request";
        if (key.equals("invoice")) { //chapu until backend verb is consistent across keys
            request_verb = "query";
        }
        a.hmi().command_trade(tid, key + " " + request_verb);
    }

    public void close_chat__worker() {
        runOnUiThread(new Runnable() {
            @Override public void run() {
                close_chat();
            }
        });
    }
    
    public void close_chat() {
        sheetBehavior.setState(BottomSheetBehavior.STATE_COLLAPSED);
    }
    
    public void openchat(byte[] chatpayload) {
        if (chat_fragment == null) {
            String lbl = peer_moniker();
            chat_fragment = new chat();
            Bundle fbundle = new Bundle();
            fbundle.putByteArray("tid", tid.value);
            fbundle.putString("lbl", lbl);
            fbundle.putByteArray("raw", chatpayload);
            chat_fragment.setArguments(fbundle);
            final androidx.fragment.app.FragmentTransaction transaction = getSupportFragmentManager().beginTransaction();
            transaction.replace(R.id.bottom_sheet, chat_fragment);
            transaction.addToBackStack(null);
            try {
                transaction.commitAllowingStateLoss();
            }
            catch (Exception e) {
            }
        }

        int st = sheetBehavior.getState();
        boolean sound = false;
        if (st == BottomSheetBehavior.STATE_HIDDEN) {
            sheetBehavior.setState(BottomSheetBehavior.STATE_EXPANDED);
            sound = true;
        }
        else if (st == BottomSheetBehavior.STATE_COLLAPSED) {
            sound = true;
        }
        if (sound) {
            a.tone.startTone(ToneGenerator.TONE_CDMA_CALL_SIGNAL_ISDN_NORMAL, 150);
        }

    }

    void archive() {
        runOnUiThread(new Thread(new Runnable() {
            @Override public void run() {
                Toast.makeText(a.main, "This trade has been archived.", 6000).show();
                finish();
            }
        }));
    }

    void close_trade() { //means archive
        final pair<ko, String> b = a.hmi().kill_trade(tid);
        if (is_ko(b.first)) {
            Toast.makeText(trader.this, a.hmi().rewrite(b.first), 6000).show();
            return;
        }
        finish();
    }

    static final int CERT_VIEWER_RESULT = 385;

    public void do_certs() {
        Intent intent = new Intent(this, certs.class);
        //intent.putExtra("tid", tid.value);
        intent.putExtra("mode", 1);
        startActivityForResult(intent, CERT_VIEWER_RESULT);
    }

    static final int PROTOCOLROLE_RESULT = 902;

    private Switch procol;
    private TextView procol_cap;
    private TextView tradeid;
    private fragment_trader ft = null;
    private role_fragment specialized_fragment = null;
    private int vf; //displayed fragment
    public hash_t tid;
    public hash_t parent_trade = null;
    public String cur_protocol = null;
    int dispatchid;
    private data_t data_ = null;
    private String src_data = null;
    public us.wallet.trader.roles_t roles = null;
    public fragment_trader forward_roles = null;
    chat chat_fragment = null;
    private BottomSheetBehavior sheetBehavior;
    private FrameLayout bottom_sheet;
    private toolbar_button button_chat;

}

