#include "api_t.h"
#include <unordered_set>
#include <fstream>
#include <cassert>

#include "config.h"

using namespace std;
using namespace us::apitool;
using c = us::apitool::api_t;

void c::collect_in_specs(map<string, vector<pair<string, string>>>& s) const {
    for (auto& i: *this) {
        i.collect_in_specs(s);
    }
}

void c::collect_out_specs(map<string, vector<pair<string, string>>>& s) const {
    for (auto& i: *this) {
        i.collect_out_specs(s);
    }
}

void c::warn_h(const string& line_comment_pfx, ostream& os) {
    os << line_comment_pfx << "------------------generated by apitool- do not edit\n\n";
}

void c::info(const string& line_comment_pfx, ostream& os) const {
   os << line_comment_pfx << " " << name << " - master file: us/api/" << src << "\n\n";
}

void c::warn_f(const string& line_comment_pfx, ostream& os) {
   os << line_comment_pfx << "-/----------------generated by apitool- do not edit\n\n";
}

void c::templ_h(const string& line_comment_pfx, const string& reffile, ostream& os) {
    os << line_comment_pfx << "------------------apitool - API Spec defined @ us/api/" << reffile << "\n\n";
}

void c::templ_f(const string& line_comment_pfx, ostream& os) {
    os << line_comment_pfx << "-/----------------apitool - End of API implementation.\n\n";
}

#ifndef HAVE_CFG
    abort
#endif

#ifdef CFG_PERMISSIONED_NETWORK
    unordered_set<string> ignored_functions;
#else
    unordered_set<string> ignored_functions{"nodes_allow", "nodes_deny"};
#endif

c* c::from_stream(istream&is) {
    c* api = new c();
    while (is.good()) {
        apifun i = apifun::from_stream(is);
        if (!is.good()) {
            break;
        }
        if (!i.name.empty()) {
            if (ignored_functions.find(i.name) == ignored_functions.end()) {
                i.api = api;
                api->push_back(i);
            }
        }
    }
    if (api->empty()) {
        auto i = apifun::example1();
        i.api = api;
        api->push_back(i);
    }
    return api;
}

void c::feedback_load(const string&) {
}

pair<c*, int> c::load(const string& process, string file, int svc_begin) {
    string nm = file;
    file = string("data/") + process + '/' + file;
    feedback_load(file);
    ifstream is(file);
    auto a = from_stream(is);
    a->name = nm;
    a->src = file;
    auto svc_end = a->compute_get_protocol_vector(svc_begin);
    //a->v = x.second;

    //a->dump_v();
    return make_pair(a, svc_end);
}

void c::dump_v() const {
    cout << '\n';
    cout << "api name " << name << " src " << src << ":\n";
    for (auto& i: v) {
        cout << i.first << ' ' << i.second << '\n';
    }
    cout << "==============" << '\n';
    for (auto& i: *this) {
        cout << "name " << i.name << " service " << i.service << " svc " << i.svc << '\n';
    }
}

int c::compute_get_protocol_vector(int svc_begin) {
    v.clear();
    v.push_back(make_pair(name + "_begin", false));
    int nextsvc = svc_begin;
    for (auto& i: *this) {
         i.compute_get_protocol_vector(name, v, nextsvc);
    }
    v.push_back(make_pair(name + "_end", false));
    assert(!v.empty());
/*
    int n = 1;
    auto f = begin();
    int s = 0;
    for (; f != end(); ++n, ++f) {
        ++s;
        f->svc = s;
        if (v[n].second) {
            ++s;
            f->svc_ret = s;
        }
    }
*/
    return nextsvc; //svc_begin + s;
}

void c::compute_netsvc(netsvc_t& netsvc, bool& ch, svcfish_db_t& db, svcfish_db_t& dbinv) {
    for (auto& i: *this) {
         i.compute_netsvc(netsvc, ch, db, dbinv);
    }
}

/*
vector<pair<string, bool>> c::compute_get_protocol_vector() {
    vector<pair<string, bool>> r;
    r.push_back(make_pair(name + "_begin", false));
    for (auto& i: *this) {
         i.compute_get_protocol_vector(name, r);
    }
    r.push_back(make_pair(name + "_end", false));
    return r;
}

int c::svc_end(int svc_begin) const {
    assert(!v.empty());
    int n = 1;
    auto f = begin();
    int s = 0;
    for (; f != end(); ++n, ++f) {
        ++s;
        if (v[n].second) {
            ++s;
        }
    }
    return svc_begin + s;
}

void c::gen_svc_lock(ostream& os) const {
}
*/

