#pragma once
#include <vector>
#include <string>
#include <string_view>
#include <map>
#include <tuple>

#include "api_t.h"

namespace us::apitool {

    using namespace std;

    struct api_t;
    struct coder;

    struct model final: vector<api_t*> {
        using netsvc_t = api_t::netsvc_t;
        using svcfish_entry_t = api_t::svcfish_entry_t;
        using svcfish_db_t = apifun::svcfish_db_t;

        model(const string& process);
        ~model();

        int add(const string& name, int svc0);
        int add_delegate(const string& name, int svc0);
        void write_netsvc(ostream&);
        void load_netsvc_run();
        void end_adding();

    public:
        string process;


        netsvc_t netsvc;

        uint8_t netsvc_serial{0};
        uint8_t prevserial{0};

        //op svc_src svc_dest comment 
        svcfish_db_t svcfish;
        svcfish_db_t svcfish_inv;
    };

}

