#include "m_t.h"

#define loglevel "gov/cash"
#define logclass "m_t"
#include <us/gov/logs.inc>

using namespace us::gov::cash;
using c = us::gov::cash::m_t;

c::m_t() {
}

c::m_t(const c& other) {
    for (auto& i: other) {
        emplace(i);
    }
}

void c::hash_data_to_sign(sigmsg_hasher_t& h) const {
    for (auto& i: *this) {
        h.write(i.first);
        h.write(i.second);
    }
}

void c::hash_data(hasher_t& h) const {
    for (auto& i: *this) {
        h.write(i.first);
        h.write(i.second);
    }
}

void c::merge(const c& other) {
    for (auto i = other.begin(); i != other.end(); ++i) {
        auto j = emplace(*i);
        if (!j.second) {
            j.first->second += string("\n") + i->second;
        }
    }
}

void c::dump(const string& prefix, ostream& os) const {
    for (auto& i: *this) {
        os << prefix << i.first << " -> " << i.second << '\n';
    }
}

