#pragma once
#include <iostream>
#include <string>
#include <stdio.h>
#include <crypto++/gcm.h>
#include <crypto++/aes.h>
#include <crypto++/osrng.h>

#include <us/gov/config.h>

#include "ec.h"

namespace us::gov::crypto {

    using namespace std;
    using CryptoPP::AutoSeededRandomPool;
    using CryptoPP::GCM;
    using CryptoPP::AES;

    struct symmetric_encryption {
        using keys = ec::keys;
        using byte = unsigned char;

        static constexpr size_t key_size = 16;
        static constexpr size_t iv_size = 12;
        static constexpr int tag_size = 16;

        static size_t encmsg_max_sz(const size_t plaintext_sz);

        ko init(const keys::priv_t&, const keys::pub_t&);
        ko encrypt(const vector<unsigned char>& src, vector<unsigned char>& dest, size_t offset);
        ko decrypt(const unsigned char* p, size_t sz, vector<unsigned char>& dest);
        ko decrypt(const vector<unsigned char>& ciphertext, vector<unsigned char>& clear);

        AutoSeededRandomPool prng_;
        byte key_[key_size];
    };

}

