#pragma once
#include <iostream>

#include <us/gov/io/seriable.h>
#include <us/gov/crypto/ec.h>
#include <us/gov/crypto/ripemd160.h>

namespace us::gov::dfs {

    using namespace std;

    struct fileattr_t: io::seriable {

        fileattr_t();
        fileattr_t(const string& path, uint32_t sz);
        fileattr_t(const fileattr_t& other): path(other.path), sz(other.sz) {}

        void hash_data_to_sign(crypto::ec::sigmsg_hasher_t&) const;
        void hash_data(crypto::ripemd160&) const;
        void dump(ostream&) const;

    public:
        size_t blob_size() const override;
        void to_blob(blob_writer_t&) const override;
        ko from_blob(blob_reader_t&) override;


    public:
        uint32_t sz;
        string path;
    };

}

