#include <us/gov/config.h>
#include <bitset>

#include "maskcoord_t.h"

#define loglevel "us/gov/engine/auth"
#define logclass "maskcoord_t"
#include <us/test/logs.inc>

#include <us/test/assert.inc>

using namespace std;
using namespace us::gov::engine::auth;
using c = us::gov::engine::auth::maskcoord_t;

void c::dump_1liner(ostream& os) const {
    if (mode == 0) {
        os << "{mask-coord " << bitset<32>(mask) << "-" << bitset<32>(coord) << '}';
    }
    else {
        os << "{maskbit " << bitset<32>(mask) << '}';
    }
}

bool c::operator == (const maskcoord_t& other) const {
    if (mask != other.mask) return false;
    if (coord != other.coord) return false;
    return true;
}

void c::clear() {
    mask = coord = 0;
}

ostream& operator << (ostream& os, const maskcoord_t& o) {
    o.dump_1liner(os);
    return os;
}

