#pragma once
#include <us/gov/config.h>

#if CFG_COUNTERS == 1
#include <iostream>

namespace us::gov::engine {

   struct counters_t final {
        uint32_t cycles{0};
        uint32_t computed_right_delta{0};
        uint32_t diff_applied{0};
        uint32_t genesis_diff_applied{0};
        uint32_t diff_discarded_not_in_sequence{0};
        uint32_t clear_db{0};
        uint32_t patch_db{0};
        uint32_t problem_opening_block_file{0};
        uint32_t problem_reading_block_file{0};
        uint32_t problem_importing_diff_file{0};
        uint32_t problem_loading_base_file{0};
        uint32_t patch_db_ok{0};
        uint32_t load_db{0};
        uint32_t problem_opening_db{0};
        uint32_t problem_reading_db{0};
        uint32_t snapshot_create{0};
        uint32_t error_renaming_db_file{0};
        uint32_t relay_local_deltas{0};
        uint32_t created_empty_local_deltas{0};
        uint32_t created_nonempty_local_deltas{0};
        uint32_t sent_vote{0};
        uint32_t recv_vote{0};
        uint32_t recv_vote_wrong_signature{0};
        uint32_t relay_vote_success{0};
        uint32_t relay_vote_fail{0};
        uint32_t recv_dup_vote{0};
        uint32_t recv_local_deltas_accepted{0};
        uint32_t recv_local_deltas_unparseable{0};
        uint32_t recv_local_deltas_wrong_signature{0};
        uint32_t recv_local_deltas_duplicate{0};
        uint32_t lost_evidences{0};
        uint32_t processed_evidences{0};
        uint32_t processed_evidences_last_block{0};
        uint32_t processed_evidences_cur_block{0};
        void dump(std::ostream&) const;
    };

}

#endif

