#pragma once
#include <map>
#include <set>

#include <us/gov/socket/types.h>

namespace us::gov::engine {

    struct evidence;
    struct peer_t;

    struct dbsync {
 
        ///Exchange of IPv4 addresses and evidences
        struct seeds_t: set<hostport_t> {

            void add_sample(seeds_t&& sample);
            seeds_t get_sample() const;
            
        };

        struct evidences_t: map<ts_t, evidence*> {
        };

        void process(peer_t* peer);

        evidences_t evidences;
        seeds_t seeds;
    };

}

