#pragma once
#include <cstdint>
#include <string>
#include <iostream>
#include "types.h"

namespace us::gov::engine {

    struct daemon_t;

    struct shell {
        static constexpr int max_type_errors{3};
        shell(daemon_t&);

    public:
        void help(ostream&) const;
        ko command(const string& cmd, ostream&);
        ko command(istream&, ostream&);
        ko command(istream&, const string& cmd, ostream&);
        bool test_node(const string& n, ostream&);

    public:
        daemon_t& d;
        int level{7};
        int cur_app{-1};
        string memory_cmd_lvl;
    };

}

