#include "protocol.h"
#include "peer_t.h"
#include "sysops_t.h"

#define loglevel "gov/engine"
#define logclass "sysops_t"
#include "logs.inc"

using namespace us::gov::engine;
using c = us::gov::engine::sysops_t;

ko c::exec(peer_t* peer, const string& cmd, ostream& os) {
    lock_guard<mutex> lock(mx);
    auto i = find(peer);
    if (i == end()) {
        i = emplace(peer, shell(this->d)).first;
    }
    log("sysop cmd. size", cmd.size(), ">", cmd, "<");
    return i->second.command(cmd, os);
}

