#include <us/gov/socket/rpc_daemon_t.h>

#include "rpc_peer_t.h"

#define loglevel "gov/relay"
#define logclass "rpc_peer_t"
#include "logs.inc"

using namespace us::gov::relay;
using c = us::gov::relay::rpc_peer_t;

bool c::process_work(datagram* d) {
    using namespace us::gov::protocol;
    assert(d != nullptr);
    assert(d->service < protocol::relay_end);
    if (d->service == relay_push) {
        if (static_cast<socket::rpc_daemon_t&>(daemon).dispatcher == nullptr) {
            log("discarding push datagram. dispatcher not available.");
            delete d;
            return true;
        }
        log("push datagram handed over to dispatcher");
        if (!static_cast<socket::rpc_daemon_t&>(daemon).dispatcher->dispatch(d)) {
            log("Not consumed");
            delete d;
        }
        return true;
    }
    return b::process_work(d);
}

#ifdef has_us_gov_relay_api
#include <us/api/generated/gov/c++/relay/cllr_rpc-impl>
#endif

