#pragma once
#include <us/gov/config.h>
#include <us/gov/io/seriable.h>

#include "protocol.h"
#include "types.h"

#if __has_include(<us/api/generated/gov/c++/socket/svc>)
    #define has_us_gov_socket_api
#endif

namespace us::gov::socket {

    using namespace gov::io;

    #ifdef has_us_gov_socket_api

        struct dto {
            using readable = us::gov::io::readable;
            using writable = us::gov::io::writable;

            #include <us/api/generated/gov/c++/socket/cllr_dto-hdr>
            #include <us/api/generated/gov/c++/socket/hdlr_dto-hdr>
        };

        struct caller_api: dto {
            #include <us/api/generated/gov/c++/socket/cllr_purevir>
        };

        struct api: caller_api {
            #include <us/api/generated/gov/c++/socket/hdlr_purevir>
        };

    #else

        struct api {};

    #endif

}

