#include <us/gov/likely.h>

#include "busyled_t.h"

#define loglevel "gov/socket"
#define logclass "busyled_t"
#include "logs.inc"

using namespace us::gov::socket;
using c = us::gov::socket::busyled_t;

c::busyled_t() {
}

c::~busyled_t() {
    delete handler;
}

void c::set() {
    if (unlikely(handler == nullptr)) return;
    log("busyled set");
    if (ref.fetch_add(1) != 0) return;
    log("trigger on_busy");
    handler->on_busy();
}

void c::reset() {
    if (unlikely(handler == nullptr)) return;
    log("busyled reset");
    if (ref.fetch_sub(1) != 1) return;
    log("trigger on_idle");
    handler->on_idle();
}

void c::set_handler(handler_t* h) {
    delete handler;
    handler = h;
}

