#include "db_t.h"

#define loglevel "gov/sys"
#define logclass "db_t"
#include <us/gov/logs.inc>

using c = us::gov::sys::db_t;
using namespace us::gov;
using namespace std;

c::db_t() {
    clear();
}

c::db_t(c&& other) {
    sensors = other.sensors;
}

c::~db_t() {
}

void c::dump(const string& prefix, ostream& os) const {
    lock_guard<mutex> lock(mx);
    os << prefix << sensors.size() << " sensors:\n";
    sensors.dump(prefix + "    ", os);
}

void c::clear() {
    lock_guard<mutex> lock(mx);
    sensors.clear();
}

size_t c::blob_size() const {
    return blob_writer_t::blob_size(sensors);
}

void c::to_blob(blob_writer_t& writer) const {
    writer.write(sensors);
}

ko c::from_blob(blob_reader_t& reader) {
    {
        auto r = reader.read(sensors);
        if (is_ko(r)) return r;
    }
    return ok;
}

