#include <thread>
#include <chrono>
#include <fstream>

#include <us/gov/vcs.h>
#include <us/gov/crypto/base58.h>
#include <us/gov/engine/net_daemon_t.h>
#include <us/gov/likely.h>

#include "install_script.h"
#include "install_script_response.h"
#include "types.h"
#include "delta.h"

#define loglevel "gov/sys"
#define logclass "delta"
#include <us/gov/logs.inc>

using namespace us::gov::sys;
using c = us::gov::sys::delta;

c::delta() {
}

c::~delta() {
}

void c::dump(const string& prefix, ostream& os) const {
    g.dump(prefix, os);
}

uint64_t c::merge(engine::app::local_delta* other0) {
    local_delta* other = static_cast<local_delta*>(other0);
    m.emplace(other->id, other->sensor);
    log("merge local_delta src=", other->id, "new size", m.size());
    b::merge(other0);
    return 0;
}

void c::end_merge() {
    log("end_merge. total sensors received", m.size());
}

size_t c::blob_size() const {
    return blob_writer_t::blob_size(m);
}

void c::to_blob(blob_writer_t& writer) const {
    writer.write(m);
}

ko c::from_blob(blob_reader_t& reader) {
    {
        auto r = reader.read(m);
        if (is_ko(r)) return r;
    }
    return ok;
}

