#include <functional>

#include "bgtask.h"

#define loglevel "gov"
#define logclass "wbgtask"
#include <us/gov/logs.inc>

#if CFG_LOGS__GOV_CONCUR == 0
    #if CFG_LOGS == 1
        #undef log
        #define log (void)sizeof
    #endif
#endif

using namespace us::gov;
using c = us::gov::wbgtask;
using namespace chrono;

c::wbgtask(function<void ()> onwakeup): b(bind(&c::run, this), onwakeup) {
}

c::~wbgtask() {
}

void c::run() {
    task_init();
    while (isup()) {
        task();
        collect_();
    }
    task_cleanup();
}

void c::collect_() {
    if (reset_wait()) {
        return;
    }
    collect();
    reset_wait();
    return;
}


