package us.gov.auth;
import us.gov.io.blob_reader_t;                                                                // blob_reader_t
import us.gov.io.blob_writer_t;                                                                // blob_writer_t
import us.CFG;                                                                                 // CFG
import us.gov.socket.datagram;                                                                 // datagram
import static us.gov.socket.types.*;                                                           // *
import us.gov.id.types.*;                                                                      // *
import us.ko;                                                                                  // ko
import java.io.PrintStream;                                                                    // PrintStream
import us.gov.protocol;                                                                        // protocol
import java.security.PublicKey;                                                                // PublicKey
import java.net.Socket;                                                                        // Socket

public abstract class peer_t extends us.gov.id.peer_t implements api {


    public enum stage_t {
        denied,
        authorized,
        num_stages;

        public short asShort() {
            return (short)ordinal();
        }
        public static stage_t fromShort(short i) {
            return stage_t.values()[i];
        }
    };

    public String[] stagestr = {"denied", "authorized"};

    public peer_t(rpc_daemon_t rpc_daemon) {
        super(rpc_daemon);
    }

    public peer_t(rpc_daemon_t rpc_daemon, Socket sock) {
        super(rpc_daemon, sock);
    }

    @Override public ko verification_completed(final pport_t rpport, final pin_t pin, request_data_t request_data) {
        {
            ko r = super.verification_completed(rpport, pin, request_data);
            if (ko.is_ko(r)) {
                return r;
            }
        }
        ko r = authorize(pubkey, pin, request_data);
        if (ko.is_ko(r)) {
            return r;
        }
        stage = stage_t.authorized;
        return ko.ok;
    }

    public abstract ko authorize(final PublicKey pub, final pin_t pin, request_data_t request_data);

    @Override public boolean process_work(datagram d) {
        switch (d.service.value) {
            //#include <us/api/generated/gov/java/auth/hdlr_svc-router>
            //------------------------------------------------------------__begin__------generated by configure, do not edit.
            //content of file: <us/api/generated/gov/java/auth/hdlr_svc-router>
            // auth - master file: us/api/data/gov/auth

            case protocol.auth_f1: { return process_async_api__auth_f1(d); }
            //-/----------------------------------------------------------___end___------generated by configure, do not edit.
        }
        return super.process_work(d);
    }

    //#include <us/api/generated/gov/java/auth/hdlr_svc_handler-impl>
    //------------------------------------------------------------__begin__------generated by configure, do not edit.
    //content of file: <us/api/generated/gov/java/auth/hdlr_svc_handler-impl>
    // auth - master file: us/api/data/gov/auth

    boolean process_async_api__auth_f1(datagram d) {
        {
            ko r = handle_f1();
            if (ko.is_ko(r)) {
                process_ko_work(d.decode_channel(), d.decode_sequence(), r);
                return true; //processed
            }
        }
        return true; //processed
    }
    //-/----------------------------------------------------------___end___------generated by configure, do not edit.

    //------------------apitool - API Spec defined @ us/api/generated/gov/java/auth/hdlr_local-impl

    @Override public ko handle_f1() {
        // Implement here.

        return KO_10210;
    }

    //-/----------------apitool - End of API implementation.

    //#include <us/api/generated/gov/java/auth/cllr_rpc-impl>
    //------------------------------------------------------------__begin__------generated by configure, do not edit.
    //content of file: <us/api/generated/gov/java/auth/cllr_rpc-impl>
    @Override public ko call_f1() {
        return send1(blob_writer_t.get_datagram(daemon.channel, new svc_t(protocol.auth_f1), new seq_t(0)));
    }
    //-/----------------------------------------------------------___end___------generated by configure, do not edit.

    @Override public void dump(final String prefix, PrintStream os) {
        os.println(prefix + "auth::peer_t: idle(recv) ");
        super.dump(prefix, os);
    }

    public stage_t stage = stage_t.denied;

}


