package us.gov.cli;
import us.CFG;                                                                                 // CFG
import static us.gov.socket.types.channel_t;                                                   // channel_t
import us.gov.socket.client;                                                                   // client
import static us.gov.socket.datagram.dispatcher_t;                                             // dispatcher_t
import us.gov.crypto.ec;                                                                       // ec
import static us.gov.id.types.*;                                                               // *
import static us.gov.socket.types.*;                                                           // *
import static us.ko.is_ko;                                                                     // is_ko
import java.security.KeyPair;                                                                  // KeyPair
import us.ko;                                                                                  // ko
import static us.ko.ok;                                                                        // ok
import java.io.PrintStream;                                                                    // PrintStream
import static us.gov.id.peer_t.role_t;                                                         // role_t
import us.gov.io.screen;                                                                       // screen
import java.util.Stack;                                                                        // Stack

public class rpc_daemon_t extends us.gov.engine.rpc_daemon_t {


    public rpc_daemon_t(final KeyPair keys, channel_t channel, final shostport_t shostport, final role_t role, dispatcher_t dispatcher) {
        super(channel, dispatcher);
        this.id = keys;
        this.shostport = shostport;
        this.role = role;
        this.parent = null;
    }

    public rpc_daemon_t(hmi parent, final KeyPair keys, final shostport_t shostport, final role_t role, dispatcher_t dispatcher) {
        super(parent.p.channel, dispatcher);
        this.id = keys;
        this.shostport = shostport;
        this.role = role;
        this.parent = parent;
    }

    @Override public us.gov.socket.client create_client() {
        return new rpc_peer_t(this);
    }

    @Override public ko connect() {
        return connect(new pin_t(0), new request_data_t());
    }

    public ko connect(pin_t pin, request_data_t request_data) {
        ko r = get_peer().connect(shostport, new pport_t(0), pin, role, request_data, true);
        if (is_ko(r)) {
            return r;
        }
        peer.disable_recv_timeout();
        handler.signal_connected();
        return ok;
    }

    @Override public void on_connect(client peer, ko r) {
        super.on_connect(peer, r);
        if (parent != null) parent.on_connect(r);
    }

    public void verification_completed(boolean verif_ok) {
        if (parent != null) parent.verification_completed(verif_ok);
    }

    public void verification_result(request_data_t request_data) {
        if (parent != null) parent.verification_result(request_data);
    }

    public void on_I_disconnected(reason_t reason) {
        if (parent != null) parent.on_I_disconnected(reason);
    }

    public void on_peer_disconnected(reason_t reason) {
        if (parent != null) parent.on_peer_disconnected(reason);
    }

    public static void apihelp(final String prefix, PrintStream os) {
        os.println(prefix + "track <xtime>           Tracking info for transaction.");
        os.println(prefix + "n|nodes                 Node list.");
        os.println(prefix + "lookup_node <addr>      Node info by addresas.");
        os.println(prefix + "w|wallets               Wallet list.");
        os.println(prefix + "lookup_wallet <addr>    Wallet info by address.");
        os.println(prefix + "fetch_accounts {<addr>} Accounts by addreses.");
    }

    @Override public void on_stop() {
        super.on_stop();
        if (parent != null) parent.on_stop();
    }

    @Override public KeyPair get_keys() { return id; }

    public rpc_peer_t get_peer() { return (rpc_peer_t)peer; }

    public void upgrade_software() {
        if (parent == null) {
            return;
        }
        parent.upgrade_software();
    }

    public KeyPair id;
    public shostport_t shostport;
    public role_t role;

    hmi parent;
}

