package us.gov.socket;
import us.gov.io.blob_writer_t;                                                                // blob_writer_t
import us.gov.socket.outbound.caller_daemon_t;                                                 // caller_daemon_t
import us.CFG;                                                                                 // CFG
import static us.gov.socket.types.*;                                                           // *
import static us.ko.is_ko;                                                                     // is_ko
import us.ko;                                                                                  // ko
import us.pair;                                                                                // pair
import java.io.PrintStream;                                                                    // PrintStream
import us.gov.protocol;                                                                        // protocol
import us.string;                                                                              // string

public abstract class daemon0_t extends caller_daemon_t {


    public daemon0_t(channel_t channel) {
        this.channel = channel;
    }

    public void process_ok_work(peer_t peer, datagram d) {
        assert d != null;
        send1(peer, d);
    }

    public boolean process_unhandled(client peer, datagram d) {
        return rendezvous.arrived(d);
    }

    public String rewrite(ko r) {
        if (is_ko(r)) {
            assert r.msg != null;
            return r.msg;
        }
        return "";
    }

    public void process_ko_work(peer_t peer, final seq_t seq, ko r) {
        process_ko_work(peer, channel, seq, r);
    }

    public void process_ko_work(peer_t peer, final channel_t channel, final seq_t seq, ko r) {
        assert ko.is_ko(r);
        String e = rewrite(r);
        peer.send1(blob_writer_t.get_datagram(channel, new svc_t(protocol.socket_error), seq, new string(e)));
    }

    public boolean outbound_traffic__goes_encrypted() {
        return encrypt_traffic;
    }

    @Override public void dump(final String prefix, PrintStream os) {
        os.println(prefix + "socket::daemon_t:");
        super.dump(prefix, os);
    }

    public void on_destroy_(client peer) {
    }

    public abstract busyled_t recv_led();
    public abstract void attach(client peer);
    public abstract void detach(client peer);

    public void on_connect(client peer, ko err) {}

    public pair<ko, datagram> sendrecv(client peer, datagram d, string remote_error) {
        return rendezvous.sendrecv(peer, d, remote_error);
    }

    public channel_t channel;

}

