package us.gov.socket.outbound;
import us.CFG;                                                                                 // CFG
import us.gov.socket.client;                                                                   // client
import us.gov.socket.datagram;                                                                 // datagram
import java.util.Date;                                                                         // Date
import static us.gov.socket.types.*;                                                           // *
import us.ko;                                                                                  // ko
import us.pair;                                                                                // pair
import java.io.PrintStream;                                                                    // PrintStream

public class caller_daemon_t extends send_queue_t {


    public caller_daemon_t() {
        rendezvous = new rendezvous_t(this);
    }

    public ko start() {
        return super.start();
    }

    public void stop() {
        super.stop();
        rendezvous.flush();
    }

    public ko send1(client peer, datagram d0) {
        if (d0 == null) {
            ko r = new ko("KO 30291 Not sending null datagram.");
            return r;
        }
        if (peer.sendref.get() < 0) {
            ko r = new ko("KO 90162 Client waiting to die.");
            return r;
        }
        int pri = d0.decode_service().value;
        if (peer.peer_api_v.value != api_v.value) { 
            if (peer.peer_api_v.value < api_v.value || peer.peer_api_v.value == 255) {
                svc_t svc = new svc_t(pri);
                peer.translate_svc(svc, false);
                d0.encode_service(svc);
            }
        }
        pair<ko, datagram> d = peer.encrypt0(d0);
        if (ko.is_ko(d.first)) {
            assert d.second == null;
            return d.first;
        }
        peer.activity.set(new Date().getTime());

        super.send(d.second, peer, pri);
        return ko.ok;
    }

    public void dump(final String prefix, PrintStream os) {
        os.println(prefix + "Hello from socket::caller_daemon");
        os.println("sendq daemon active:" + is_active());
        super.dump(prefix, os);
    }

    public rendezvous_t rendezvous;
    public boolean encrypt_traffic = true;
    public api_v_t api_v = new api_v_t(0);

}

