package us.wallet.engine;
import java.util.ArrayList;                                                                    // ArrayList
import us.gov.crypto.base58;                                                                   // base58
import us.gov.io.blob_reader_t;                                                                // blob_reader_t
import us.gov.io.types.blob_t;                                                                 // blob_t
import us.gov.io.blob_writer_t;                                                                // blob_writer_t
import us.CFG;                                                                                 // CFG
import java.util.Date;                                                                         // Date
import us.gov.crypto.ec;                                                                       // ec
import static us.gov.crypto.types.*;                                                           // *
import static us.gov.id.types.*;                                                               // *
import static us.gov.socket.types.*;                                                           // *
import us.stdint.*;                                                                            // *
import static us.ko.is_ko;                                                                     // is_ko
import java.security.KeyPair;                                                                  // KeyPair
import us.ko;                                                                                  // ko
import static us.ko.ok;                                                                        // ok
import java.io.PrintStream;                                                                    // PrintStream
import static us.gov.io.types.blob_t.serid_t;                                                  // serid_t
import us.string;                                                                              // string
import java.util.TreeMap;
import java.util.Set;
import java.util.Map;
import us.wallet.trader.protocol_selection_t;                                                                // blob_writer_t
import us.wallet.trader.bookmarks_t;                                                                // blob_writer_t
import us.gov.crypto.ripemd160.hash_t;

@SuppressWarnings("serial")
public class data_sources_index_t extends ArrayList<data_sources_index__item_t> implements us.gov.io.seriable {


    public void dump(PrintStream os) {
        for (data_sources_index__item_t i: this) {
            os.println(i.name.value + " " + i.address.encode());
        }
    }

    public static serid_t my_serid_id = new serid_t((short)'I');

    @Override public serid_t serial_id() { return my_serid_id; }

    @Override public int blob_size() {
        int sz = blob_writer_t.sizet_size(size());
        for (data_sources_index__item_t i: this) {
            sz += i.blob_size();
        }
        return sz;
    }

    @Override public void to_blob(blob_writer_t writer) {
        writer.write_sizet(size());
        for (data_sources_index__item_t i: this) {
            i.to_blob(writer);
        }
    }

    @Override public ko from_blob(blob_reader_t reader) {
        clear();
        uint64_t sz = new uint64_t();
        {
            ko r = reader.read_sizet(sz);
            if (is_ko(r)) return r;
        }
        try {
            for (long i = 0; i < sz.value; ++i) {
                data_sources_index__item_t item = new data_sources_index__item_t();
                {
                    ko r = item.from_blob(reader);
                    if (is_ko(r)) {
                        return r;
                    }
                }
                add(item);
            }
        }
        catch (Exception e) {
            return new ko("KO 89283 TTE 2 Invalid read. " + e.getMessage());
        }
        return ok;
    }

}

