package us.wallet.engine;
import java.util.ArrayList;                                                                    // ArrayList
import us.gov.crypto.base58;                                                                   // base58
import us.gov.io.blob_reader_t;                                                                // blob_reader_t
import us.gov.io.types.blob_t;                                                                 // blob_t
import us.gov.io.blob_writer_t;                                                                // blob_writer_t
import us.CFG;                                                                                 // CFG
import java.util.Date;                                                                         // Date
import us.gov.crypto.ec;                                                                       // ec
import static us.gov.crypto.types.*;                                                           // *
import static us.gov.id.types.*;                                                               // *
import static us.gov.socket.types.*;                                                           // *
import us.stdint.*;                                                                            // *
import static us.ko.is_ko;                                                                     // is_ko
import java.security.KeyPair;                                                                  // KeyPair
import us.ko;                                                                                  // ko
import static us.ko.ok;                                                                        // ok
import java.io.PrintStream;                                                                    // PrintStream
import static us.gov.io.types.blob_t.serid_t;                                                  // serid_t
import us.string;                                                                              // string

@SuppressWarnings("serial")
public class wallet_connections_t extends ArrayList<wallet_connection_t> implements us.gov.io.seriable {


    public wallet_connections_t() {
    }

    public static serid_t my_serid_id = new serid_t((short)'x');

    @Override public serid_t serial_id() { return my_serid_id; }

    @Override public int blob_size() {
        int sz = blob_writer_t.sizet_size(size());
        for (wallet_connection_t entry: this) {
            sz += blob_writer_t.blob_size(entry);
        }
        return sz;
    }

    @Override public void to_blob(blob_writer_t writer) {
        writer.write_sizet(size());
        for (wallet_connection_t entry: this) {
            writer.write(entry);
        }
    }

    @Override public ko from_blob(blob_reader_t reader) {
        clear();
        uint64_t sz = new uint64_t();
        {
            ko r = reader.read_sizet(sz);
            if (is_ko(r)) return r;
        }
        try {
            for (long i = 0; i < sz.value; ++i) {
                wallet_connection_t wallet_connection = new wallet_connection_t();
                {
                    ko r = reader.read(wallet_connection);
                    if (is_ko(r)) {
                        return r;
                    }
                }
                add(wallet_connection);
            }
        }
        catch (Exception e) {
            return new ko("KO 88482 Invalid read. wallet_connection.");
        }
        return ok;
    }

}

