package us.wallet.trader.bootstrap;
import us.gov.io.blob_reader_t;                                                                // blob_reader_t
import us.gov.io.blob_writer_t;                                                                // blob_writer_t
import us.CFG;                                                                                 // CFG
import us.stdint.*;                                                                            // *
import java.io.InputStream;                                                                    // InputStream
import static us.ko.is_ko;                                                                     // is_ko
import us.ko;                                                                                  // ko
import static us.ko.ok;                                                                        // ok
import java.io.OutputStream;                                                                   // OutputStream
import us.pair;                                                                                // pair
import java.io.PrintStream;                                                                    // PrintStream
import java.util.Scanner;                                                                      // Scanner
import us.wallet.trader.protocol_selection_t;                                                                      // Scanner
import static us.gov.io.types.blob_t.serid_t;                                                  // serid_t
import java.util.ArrayList;

@SuppressWarnings("serial")
public class protocols_t extends ArrayList<protocol_selection_t> implements us.gov.io.seriable {


    @Override public serid_t serial_id() { return serid_t.no_header; }

    @Override public int blob_size() {
        int sz = blob_writer_t.sizet_size(size());
        for (protocol_selection_t o: this) {
            sz += o.blob_size();
        }
        return sz;
    }

    @Override public void to_blob(blob_writer_t writer) {
        writer.write_sizet(size());
        for (protocol_selection_t o: this) {
            o.to_blob(writer);
        }
    }

    @Override public ko from_blob(blob_reader_t reader) {
        clear();
        uint64_t sz = new uint64_t();
        {
            ko r = reader.read_sizet(sz);
            if (is_ko(r)) return r;
        }
        try {
            for (long i = 0; i < sz.value; ++i) {
                protocol_selection_t protocol_selection = new protocol_selection_t();
                {
                    ko r = protocol_selection.from_blob(reader);
                    if (is_ko(r)) {
                        return r;
                    }
                }
                add(protocol_selection);
            }
        }
        catch (Exception e) {
            return new ko("KO 81382 Invalid read.");
        }
        return ok;
    }

}

