package us.wallet.trader.workflow;
import us.gov.io.blob_reader_t;                                                                // blob_reader_t
import us.gov.io.blob_writer_t;                                                                // blob_writer_t
import us.CFG;                                                                                 // CFG
import static us.gov.io.types.*;                                                               // *
import static us.ko.*;                                                                         // *
import static us.stdint.*;                                                                     // *
import us.ko;                                                                                  // ko
import us.pair;                                                                                // pair
import static us.gov.io.types.blob_t.serid_t;                                                  // serid_t
import us.string;                                                                              // string
import us.wallet.trader.cert.doc0_t;
import us.wallet.trader.cert.expiry_doc_t;

public abstract class item_t implements us.gov.io.seriable {


    public abstract doc0_t create_doc();

    public pair<ko, doc0_t> doc_from_blob(blob_reader_t reader) {
        uint8_t hasdoc = new uint8_t();
        {
            ko r = reader.read(hasdoc);
            if (is_ko(r)) return new pair<ko, doc0_t>(r, null);
        }
        if (hasdoc.value == 0) {
            return new pair<ko, doc0_t>(ok, null);
        }
        doc0_t d = create_doc();
        assert d != null;
        {
            ko r = reader.read(d);
            if (is_ko(r)) {
                return new pair<ko, doc0_t>(r, null);
            }
        }
        return new pair<ko, doc0_t>(ok, d);
    }

    @Override public serid_t serial_id() { return serid_t.no_header; }

    @Override public int blob_size() {
        int sz = blob_writer_t.blob_size(name) + blob_writer_t.blob_size(long_name) + 1;
        if (doc != null) sz += blob_writer_t.blob_size(doc);
        return sz;
    }

    @Override public void to_blob(blob_writer_t writer) {
        writer.write(name);
        writer.write(long_name);
        uint8_t hasdoc = new uint8_t(doc == null ? (short)0 : (short)1);
        writer.write(hasdoc);
        if (doc != null) writer.write(doc);
    }

    @Override public ko from_blob(blob_reader_t reader) {
        {
            string n = new string();
            {
                ko r = reader.read(n);
                if (is_ko(r)) return r;
            }
            if (name.isEmpty()) {
                name = n.value;
            }
            else {
                if (!n.value.equals(name)) {
                    ko r = new ko("KO 40329 Workflow item name mismatch");
                    return r;
                }
            }
        }
        {
            string n = new string();
            {
                ko r = reader.read(n);
                if (is_ko(r)) return r;
            }
            if (long_name.isEmpty()) {
                long_name = n.value;
            }
            else {
                if (!n.value.equals(long_name)) {
                    ko r = new ko("KO 40328 Workflow item long_name mismatch");
                    return r;
                }
            }
        }
        {
            pair<ko, doc0_t> r = doc_from_blob(reader);
            if (is_ko(r.first)) {
                assert r.second == null;
                return r.first;
            }
            assert r.second != null;
            doc = r.second;
        }
        return ok;
    }

    public String name = "";
    public String long_name = "";
    public doc0_t doc = null;

}

