#pragma once

#include <iostream>
#include <cassert>

#include <us/gov/crypto/ripemd160.h>
#include <us/gov/cli/hmi.h>
#include <us/wallet/cli/hmi.h>

namespace us::test {

    int core0_main(int argc, char** argv);

    using namespace std;
    using hash_t = us::gov::crypto::ripemd160::value_type;

    struct govx_t: gov::cli::hmi {
        using b = gov::cli::hmi;

        using b::hmi;

        void on_stop() override {
            b::on_stop();
            if (_assert_on_stop) {
                cerr << "Unexpectedly hmi instance " << this << " stopped" << endl;
                assert(false);
            }
        }

        void setup_signals(bool) override {}

        bool _assert_on_stop = true;
    };

    struct walletx_t : wallet::cli::hmi {
        using b = wallet::cli::hmi;

        using b::hmi;

        void on_stop() override {
            b::on_stop();
            if (_assert_on_stop) {
                cerr << "Unexpectedly hmi instance " << this << " stopped" << endl;
                assert(false);
            }
        }

        void setup_signals(bool) override {}

        bool _assert_on_stop = true;
    };

    using cash_t = int64_t;

}

