#pragma once
#include <us/gov/bgtask.h>
#include <us/gov/crypto/types.h>
#include <us/gov/engine/net.h>

namespace us::test {

    struct pld {
        pld(const hash_t& h, int numnodes): h(h) { a.resize(numnodes, 0); }
        hash_t h;
        vector<int> a;
    };

    struct evc_t: map<chrono::system_clock::time_point, pld> {
        evc_t(int numnodes);
        void wait_empty();
        void purge_();
        void newev( hash_t h, int srcport);
        void recv(const hash_t&h, int ndx);
        void dump(ostream& os) const;

        int numnodes{0};
        int completed{0};
        int total{0};
        mutable mutex mx;
    };

    struct evsseen_t: unordered_set<hash_t> {
        mutex mx;
    };

}

