#pragma once

#include <map>
#include <set>
#include <vector>
#include "sim.h"

namespace us::sim {

    using namespace std;

    struct node_t;

    struct account {
        int balance;
    };

    struct db_t: map<address_t, account> {
        using b = map<address_t, account>;

        vector<node_t*> nodes;

        int version{0};

        db_t();
        db_t(const db_t&);
        db_t* split(int bit);
        void dump(const string& pfx, ostream& os) const;

        set<node_t*> random_nodes(int);
        node_t* random_node();
    };

}

