#pragma once

#include <us/gov/crypto/ripemd160.h>
#include <random>

#define TX_SER_SZ 600 //avg size in bytes of a serialized transaction
#define DELTAS_SZ 10000 //avg size in bytes of a delta packet (part of consensus)
#define VOTE_SZ 160 //avg size in bytes of a vote packet (part of consensus)

#define SPLIT_SZ 32

namespace us::sim {

    struct clock {


        uint64_t time{0};
        static clock instance;
    };

    using hash_t = us::gov::crypto::ripemd160::value_type;
    using address_t = hash_t;

    static mt19937 rng(time(0));
    static uniform_int_distribution<mt19937::result_type> distu64;


    void sim_main();
}

