#pragma once
#include <iostream>
#include <vector>

namespace us::test {

    using namespace std;

    struct test_platform {
        test_platform(ostream& os);
        virtual ~test_platform();

        void print_stacktrace(ostream&out, unsigned int max_frames = 10);

        template<typename t>
        void check(const t& v, const t& expected) {
            if (v == expected) return;
            os << "Fail. Expected " << expected << ", got " << v << '\n';
            abort();
        }

        template<typename t>
        void check(const vector<t>& v, const vector<t>& expected) {
            if (v.size() != expected.size()) {
                os << "Fail. vector sizes differ. Expected " << expected.size() << ", got " << v.size() << '\n';
                abort();
            }
            if (v == expected) return;
            os << "Fail. content of vectors of size " << v.size() << " differ.\n";
            auto i = v.begin();
            auto e = expected.begin();
            while(i != v.end()) {
                os << +*i << ' ' << +*e << '\n';
                ++i; ++e;
            }
            abort();
        }

        void abort();
        void fail(const string& reason);

        ostream& os;
    };


}

