#include "rpc_peer_t.h"
#include "rpc_daemon_t.h"
#include "types.h"

#define loglevel "wallet/cli"
#define logclass "rpc_peer_t"
#include <us/gov/logs.inc>

using namespace us::wallet::cli;
using c = us::wallet::cli::rpc_peer_t;

void c::dump(const string& prefix, ostream& os) const {
    os << prefix << "cli: \n";
}

void c::dump_all(const string& prefix, ostream& os) const {
    dump(prefix, os);
    b::dump_all(prefix, os);
}

void c::on_peer_disconnected(const reason_t& reason) {
    log("on_peer_disconnected", reason);
    b::on_peer_disconnected(reason);
    static_cast<rpc_daemon_t&>(daemon).on_peer_disconnected(reason);
}

void c::on_I_disconnected(const reason_t& reason) {
    log("on_I_disconnected", reason);
    b::on_I_disconnected(reason);
    static_cast<rpc_daemon_t&>(daemon).on_I_disconnected(reason);
}

ko c::verification_completed(pport_t pport, pin_t pin, request_data_t& request_data) {
    log("verification_completed", pport, pin);
    auto r = b::verification_completed(pport, pin, request_data);
    static_cast<rpc_daemon_t&>(daemon).verification_completed(verification_is_fine());
    return r;
}

void c::verification_result(request_data_t&& request_data) {
    static_cast<rpc_daemon_t&>(daemon).verification_result(move(request_data));
}

