#pragma once
#include <map>
#include <string>
#include <mutex>
#include <functional>

#include <us/gov/config.h>
#include <us/gov/io/seriable_vector.h>
#include <us/gov/io/blob_reader_t.h>

namespace us::wallet::engine {

    struct data_sources_index__item_t: us::gov::io::seriable {
    public:
        void dump(ostream&) const;

    public: //serialization blob
        size_t blob_size() const override;
        void to_blob(blob_writer_t&) const override;
        ko from_blob(blob_reader_t&) override;

    public:
        string name;
        hash_t address;
    };


    struct data_sources_index_t: us::gov::io::seriable_vector<data_sources_index__item_t> {
        using serid_t = us::gov::io::blob_reader_t::serid_t;

        void dump(ostream&) const;

        serid_t serial_id() const override { return 'I'; }
    };

}

