#include "peer_t.h"
#include <sstream>
#include "types.h"

#include <us/gov/socket/datagram.h>
#include <us/wallet/engine/daemon_t.h>
#include <us/wallet/trader/qr_t.h>
#include <us/wallet/trader/traders_t.h>
#include <us/wallet/wallet/local_api.h>

#define loglevel "wallet/engine"
#define logclass "peer_t__pairing"
#include <us/gov/logs.inc>
#include <us/gov/socket/dto.inc>

using namespace us::wallet::engine;
using c = us::wallet::engine::peer_t;

//const char* c::KO_10428 = "KO 10428 Traders unavailale.";

#include <us/api/generated/wallet/c++/r2r/cllr_rpc-impl>

bool c::process_work__r2r(datagram* d) {
    using namespace protocol;
    switch(d->service) {
        #include <us/api/generated/wallet/c++/r2r/hdlr_svc-router>
    }
    return false;
}

#include <us/api/generated/wallet/c++/r2r/hdlr_svc_handler-impl>

//------------------apitool - API Spec defined @ us/api/generated/wallet/c++/r2r/hdlr_local-impl

ko c::handle_trading_msg(seq_t seq, trading_msg_in_dst_t&& o_in) {
    log("trading_msg", seq);
    /// in:
    ///     hash_t tid;
    ///     uint16_t code;
    ///     vector<uint8_t> payload;
assert(false);
    trading_msg2_in_dst_t o_in2;
    o_in2.route = 0;
    o_in2.tid = move(o_in.tid);
    o_in2.code = o_in.code;
    o_in2.payload = move(o_in.payload);
    return handle_trading_msg2(seq, move(o_in2));
    //log("trading message arrived for trade", o_in.tid, "code", o_in.code);
    //return static_cast<daemon_t&>(daemon).trades.trading_msg(*this, o_in.code, o_in.tid, move(o_in.payload));
/*
    if (is_ko(r)) {
        log("unable to process trading msg, disconnecting peer.", r);
        disconnect(0, r);
        return r;
    }
    return ok;
*/
return "KO 77887";
}

ko c::handle_trading_msg2(seq_t seq, trading_msg2_in_dst_t&& o_in) {
    log("trading_msg2", seq);
    /// in:
    ///     uint64_t route;
    ///     hash_t tid;
    ///     uint16_t code;
    ///     vector<uint8_t> payload;

    log("trading message arrived for trade", o_in.tid, "code", o_in.code, "route", o_in.route);
    return static_cast<daemon_t&>(daemon).trades.trading_msg(*this, o_in.route, o_in.tid, o_in.code, move(o_in.payload));
}


//-/----------------apitool - End of API implementation.

