#pragma once
#include "trader_protocol.h"

#include <set>

#include "business.h"
#include "protocol_selection_t.h"
#include "bootstrap/protocols_t.h"

namespace us::wallet::trader {

    struct lib0_t: set<business_t*> {

        lib0_t();
        virtual ~lib0_t();

        virtual void cleanup();

        virtual pair<ko, business_t*> create_business() = 0;  //returns weak ptr
        virtual ko delete_business(business_t*);
        virtual ko good() const = 0;

    };

    struct trades_t;

    struct libs_t final: map<protocol_selection_t, lib0_t*> {
        using protocols_t = us::wallet::trader::bootstrap::protocols_t;

        libs_t(trades_t&);
        libs_t(const libs_t&) = delete;
        ~libs_t();

        pair<ko, business_t*> create_business(const protocol_selection_t&);
        ko delete_business(business_t*);
        protocols_t available_protocol_selections() const;
        void load();
        static protocol_selection_t extract_protocol_selection(const string& filename);

    private:
        void load_bank_factory();
        void load_plugins();

        trades_t& parent;
    };

}

