#pragma once
#include <unordered_map>
#include <map>
#include <string>
#include <vector>
#include <iostream>

#include <us/wallet/trader/cert/doc0_t.h>
//#include "doc0_t.h"

namespace us::wallet::trader::workflow {

    using namespace std;
    using magic_t = us::wallet::trader::cert::doc0_t::magic_t;

    struct doctype_processor_t: pair<string, string> {
        using b = pair<string, string>;
        using b::pair;

        void to_stream(ostream&) const;
        ko from_stream(istream&);
    };

    struct doctype_processors_t: map<magic_t, vector<doctype_processor_t>> { ///TODO: use unordered_map?
        doctype_processors_t();
        static constexpr uint8_t version{1};
        void add(magic_t, const string&, const string&);
        void add(magic_t m, doctype_processor_t&&);
        void to_stream(ostream&) const;
        ko from_stream(istream&);
        ko load(const string& filename);
        ko save(const string& filename);
    };

}

