#pragma once
#include <us/gov/io/seriable.h>

#include <us/wallet/engine/protocol.h>
#include <us/wallet/engine/data_sources_index_t.h>
#include <us/wallet/wallet/timeseries_index_t.h>
#include <us/wallet/engine/dto.h>
#include <us/wallet/trader/bookmarks_t.h>
#include <us/wallet/trader/endpoint_t.h>
#include <us/wallet/trader/cert/cert_index_t.h>
#include <us/wallet/trader/cert/cert_t.h>

#include "types.h"

namespace us::wallet::engine {

    struct peer_t;

}

namespace us::wallet::wallet {

    using blob_writer_t = gov::io::blob_writer_t;
    using blob_reader_t = gov::io::blob_reader_t;
    using cert_index_t = us::wallet::trader::cert::cert_index_t;
    using cert_t = us::wallet::trader::cert::cert_t;
    using data_sources_index_t = us::wallet::engine::data_sources_index_t;
    using timeseries_index_t = us::wallet::wallet::timeseries_index_t;

    struct handler_api: virtual us::wallet::engine::dto {
        #include <us/api/generated/wallet/c++/wallet/hdlr_purevir>
    };

    struct caller_api: virtual us::wallet::engine::dto {
        #include <us/api/generated/wallet/c++/wallet/cllr_purevir>
    };

}

