#include <us/gov/io/blob_writer_t.h>
#include <us/gov/io/blob_reader_t.h>

#include "tx_make_p2pkh_input.h"
#include "types.h"

#define loglevel "wallet/wallet"
#define logclass "tx_make_p2pkh_input"
#include <us/gov/logs.inc>

using namespace us::wallet::wallet;
using c = us::wallet::wallet::tx_make_p2pkh_input;

size_t c::blob_size() const {
    return blob_writer_t::blob_size(src_addr) +
        blob_writer_t::blob_size(rcpt_addr) +
        blob_writer_t::blob_size(amount) +
        blob_writer_t::blob_size(token);
}

void c::to_blob(blob_writer_t& writer) const {
    writer.write(src_addr);
    writer.write(rcpt_addr);
    writer.write(amount);
    writer.write(token);
}

ko c::from_blob(blob_reader_t& reader) {
    {
        auto r = reader.read(src_addr);
        if (is_ko(r)) return r;
    }
    {
        auto r = reader.read(rcpt_addr);
        if (is_ko(r)) return r;
    }
    {
        auto r = reader.read(amount);
        if (is_ko(r)) return r;
    }
    {
        auto r = reader.read(token);
        if (is_ko(r)) return r;
    }
    return ok;
}

