#pragma once
#include "protocol.h"
#include <us/gov/io/seriable.h>
#if __has_include(<us/api/generated/gov/c++/auth/svc>)
    #define has_us_gov_auth_api
#endif

namespace us::gov::auth {

    using namespace gov::io;

    #ifdef has_us_gov_auth_api

        struct dto {
            using readable = us::gov::io::readable;
            using writable = us::gov::io::writable;

            #include <us/api/generated/gov/c++/auth/cllr_dto-hdr>
            #include <us/api/generated/gov/c++/auth/hdlr_dto-hdr>
        };

        struct caller_api: dto {
            #include <us/api/generated/gov/c++/auth/cllr_purevir>
        };

        struct api: caller_api {
            #include <us/api/generated/gov/c++/auth/hdlr_purevir>
        };

    #else

        struct api {};

    #endif

}

