#pragma once
#include <us/gov/io/seriable.h>
#include "sigcode_t.h"

namespace us::gov::cash {

    struct locking_program_input_t final: io::seriable {

        locking_program_input_t();
        locking_program_input_t(const locking_program_input_t& other);
        ~locking_program_input_t() override;

        locking_program_input_t& operator = (const locking_program_input_t& other);

    public:
        size_t blob_size() const override;
        void to_blob(blob_writer_t&) const override;
        ko from_blob(blob_reader_t&) override;

        inline bool is_set() const { return sig.is_not_zero(); }

        void dump(ostream&) const;
        void dump_line(ostream&) const;

    public:
        sigcode_t sigcode;
        pubkey_t pubkey;
        sig_t sig{0};
    };

}

