#pragma once
#include <us/gov/io/seriable.h>
#include "sigcode_section_t.h"

namespace us::gov::cash {

    using namespace std;

    struct sigcode_t final: vector<sigcode_section_t>, io::seriable {
        using b = vector<sigcode_section_t>;
 
        sigcode_t() {}
        sigcode_t(const sigcode_t& other): b(other), ts(other.ts) {}
        sigcode_t& operator = (const sigcode_t& other) {
            static_cast<b&>(*this) = other;
            ts = other.ts;
            return *this;
        }
        ~sigcode_t() override {}

        void dump(ostream&) const;
        void dump_line(ostream&) const;

    public:
        size_t blob_size() const override;
        void to_blob(blob_writer_t&) const override;
        ko from_blob(blob_reader_t&) override;

    public:
        bool ts{true};
    };

}

