#pragma once
#include <us/gov/io/seriable.h>
#include "protocol.h"

#if __has_include(<us/api/generated/gov/c++/dfs/svc>)
    #define has_us_gov_dfs_api
#endif

namespace us::gov::dfs {

    using namespace gov::io;

    #ifdef has_us_gov_dfs_api

        struct dto {
            using readable = us::gov::io::readable;
            using writable = us::gov::io::writable;

            #include <us/api/generated/gov/c++/dfs/hdlr_dto-hdr>
            #include <us/api/generated/gov/c++/dfs/cllr_dto-hdr>
        };

        struct caller_api: dto {
            #include <us/api/generated/gov/c++/dfs/cllr_purevir>
        };

        struct api: caller_api {
            #include <us/api/generated/gov/c++/dfs/hdlr_purevir>
        };

    #else

        struct api {};

    #endif

}

