#pragma once
#include <us/gov/relay/peer_t.h>
#include <us/gov/config.h>

#include "api.h"
#include "types.h"

namespace us::gov::dfs {

    struct daemon_t;

    struct peer_t: base_ns::peer_t, api {
        using b = base_ns::peer_t;

        peer_t(daemon_t&, int sock);
        ~peer_t() override;

        bool process_work(datagram*) override;

        #ifdef has_us_gov_dfs_api
            #include <us/api/generated/gov/c++/dfs/cllr_override>
            #include <us/api/generated/gov/c++/dfs/hdlr_svc_handler-hdr>
            #include <us/api/generated/gov/c++/dfs/hdlr_override>
        #endif
    };

}

