#pragma once
#include <us/gov/engine/app.h>
#include <us/gov/peer/nodes_t.h>
#include <unordered_map>
#include <us/gov/types.h>

namespace us::gov::engine::auth {

    using nodes_t = peer::nodes_t;

    struct collusion_control_t final: unordered_map<host_t, uint8_t> {
        static uint8_t max_nodes_per_ip;
        bool allow(host_t ip_addr);
        void rm(host_t ip_addr);
        void update_(const nodes_t&); //nodes locked by caller
        void dump(ostream&) const;
    };

}

