#pragma once
#include <mutex>
#include <set>
#include <us/gov/types.h>
#include <us/gov/crypto/types.h>
#include "types.h"

namespace us::gov::engine {

    struct daemon_t;

    struct neuralyzer_t final {

        neuralyzer_t(daemon_t*);
        neuralyzer_t(const neuralyzer_t&) = delete;
        neuralyzer_t& operator = (const neuralyzer_t&) = delete;
        ~neuralyzer_t();

        void old_chain(const hash_t&);
        void get_blocks(set<hash_t>&, const hash_t&);
        int cleanup();

    private:
        void delete_chain(const hash_t&);

    public:
        daemon_t *d;
        hash_t old;
        mutex mx;
    };

}

