#pragma once
#include <unordered_map>
#include <unordered_set>
#include <mutex>

#include <us/gov/types.h>
#include <us/gov/crypto/types.h>
#include <us/gov/config.h>

#include "types.h"

namespace us::gov::engine {

    struct votes_t final {
        #if CFG_COUNTERS == 1
            unordered_map<hash_t, const hash_t> voters;
        #else
            unordered_set<hash_t> voters;
        #endif
        unordered_map<hash_t, uint64_t> votes;
        void clear();
        void dump(const string& prefix, ostream&) const;
        bool add(const pubkey_t::hash_t&, const hash_t&);
        hash_t select();
        void logline(ostream&) const;

        #ifdef CFG_PERMISSIONED_NETWORK
            hash_t master_vote{0};
        #endif

        bool closed{false};
        mutable mutex mx;
    };

}

