#pragma once
#include <us/gov/io/seriable.h>
#include <us/gov/socket/types.h>

namespace us::wallet::engine {

    struct ip4_endpoint_t final: gov::io::seriable {

        ip4_endpoint_t();
        ip4_endpoint_t(shost_t, port_t, channel_t);
        ip4_endpoint_t(host_t, port_t, channel_t);
        ip4_endpoint_t(const ip4_endpoint_t&);

    public:
        bool operator == (const ip4_endpoint_t&) const;
        string to_string() const;
        shostport_t shostport() const;

    public:
        size_t blob_size() const override;
        void to_blob(blob_writer_t&) const override;
        ko from_blob(blob_reader_t&) override;

    public:
        shost_t shost;
        port_t port;
        channel_t channel;
    };

}

