#pragma once
#include <map>
#include <string>
#include <mutex>
#include <functional>

#include <us/gov/config.h>
#include <us/gov/io/seriable_map.h>
#include <us/gov/io/blob_reader_t.h>

#include "cert_t.h"

namespace us::wallet::trader::cert {

    struct cert_index_t: us::gov::io::seriable_map<hash_t, string> {
        using serid_t = us::gov::io::blob_reader_t::serid_t;

        void dump(ostream&) const;

        serid_t serial_id() const override { return 'C'; }
    };

}

