#pragma once
#include <string>
#include <functional>

#include <us/gov/config.h>
#include <us/gov/io/seriable_vector.h>
#include <us/gov/io/blob_reader_t.h>

namespace us::wallet::wallet {

    struct timeseries_index_t: us::gov::io::seriable_vector<hash_t> {
        using serid_t = us::gov::io::blob_reader_t::serid_t;

        void dump(ostream&) const;

        void add(hash_t&& a) {
            emplace_back(move(a));
        }

        serid_t serial_id() const override { return 'T'; }
    };

}

